*  Program Ŀ
*   Application: Visual dBASE Component Builder                             
*   Description: Menu, Report, Form, and Label Converter                    
*     File Name: CB.PRG                                                     
*        Author: Inprise Corporation                                        
*  Date created: 12-31-93              Date updated: 06-09-98              
*     Copyright: (c) 1993, 1994, 1995, 1998 by Inprise Corporation,         
*                    1999 by dBASE, Inc.                                    
* 
*
*  REVISION:    $Revision:   1.0  $
*  
*  Public Release: June 1998
*
*----------------------------------------------------------------------------

#INCLUDE "CB.H"
#INCLUDE "CBRES.H"
set talk off                                     && suppress the screen

public cb,           ;
       nIndent,      ;
       fDialect,     ;
       fGenPref,     ;
       fFileSelect,  ;
       fDispGen,     ;
       nBegLine,     ;
       nEndLine,     ;
       cPoint,       ;
       cDesign,      ;
       cLdCheck,     ;
       cExcl,        ;
       cTitl, cFile

public dump
setEnvironment()                                 && establish the environment

IF file(cbPath() + "cb.dbf")
   cDataBase = cbPath() + "cb.dbf"
   use &cDataBase alias System in select() exclusive  && open the system database
   select System
else                                             && auto-build the database
   cbMsge(msgDBFFileMissing, msgSystemError)     && display error message
   clear                                         && clear the screen
   close all                                     && close all databases
   setDBWHelp()                                  && reset the dbwin help
   set safe on                                   && safety back on
   set talk on                                   && enable the screen
   cancel                                        && cancel the program
ENDIF

IF file(cbPath() + "cbproj.dbf") .and. file(cbPath() + "cbproj.dbt")   && does cbproj.dbf/cbproj.dbt exist?
   cDataBase = cbPath() + "cbproj.dbf"
   use &cDataBase alias Project in select() exclusive && open the import database
   select Project
else                                             && auto-build the database
   cbMsge(msgPRJFileMissing, msgSystemError)     && display message
   clear                                         && clear the scren
   close all                                     && close all databases
   setDBWHelp()                                  && reset the dbwin help
   set safe on                                   && safety back on
   set talk on                                   && enable the screen
   cancel                                        && cancel the program
ENDIF

select Project                                   && open the project file
zap                                              && make sure it's clean

cb = new cbMenuForm()                            && Create the main form

*----------------------------------------------------------------------
*-- Create the main menu for the form.  The MenuFile property for the
*-- form is the normal way to attach the menu, but the class definition
*-- for the menu is #include'd to avoid having to ship a .MNO file.
*----------------------------------------------------------------------
LOCAL cbMenu
cbMenu = new cbMainMenu( cb, "Root" )
cbMenu.File.Frm_to_Rpt.Enabled = ( cbCrwApi = 1 )  && disable menu options
cbMenu.File.Lbl_to_Rpl.Enabled = ( cbCrwApi = 1 )  && if crw not available

shell(False)                                     && kill the dbase window
cb.open()                                        && open the menu form
cb.setfocus()                                    && make sure the app is in focus

&&& *************************************************************************
&&& Main Menu Classes
&&& *************************************************************************

#include "cbmenu.wfm"
#include "cbmain.mnu"

FUNCTION changeDir
   setDBWHelp()                                  && switch back to dBASE's help
   cNewDir = getDir()                            && launch the directory dialog
   setCBHelp()                                   && switch back to CB's help
   IF .NOT. empty(cNewDir)                       && if a valid directory entry exists...
      cd &cNewDir                                && change the directory
   ENDIF
RETURN (Void)


FUNCTION setDBWHelp
   cHelpHome = home() + "dbasewin.hlp"           && get the current help path
   set help to &cHelpHome                        && establish the DBW help file
RETURN (Void)

FUNCTION setCBHelp
   cHelpHome = cbPath() + "cb.hlp"               && ge the proper path to the program
   set help to &cHelpHome                        && establish the CB help file
RETURN (Void)

FUNCTION launch(cTitle, cFileMask)
   setDBWHelp()                                  && switch back to dBASE's help
   cCnvtFile = getFile(cFileMask, cTitle, True, False)  && get the file to convert
   setCBHelp()                                   && switch back to CB's help

   IF .NOT. empty(cCnvtFile) .AND. file(cCnvtFile) && if there is a valid file
      cCnvtExtn = cCnvtFile                      && copy the file name
      cCnvtExtn = getExtension(cCnvtExtn)        && derive the file extension
      IF upper(substr(cFileMask, 3)) <> cCnvtExtn && make sure the selected file is the same extention type as the intended file
         cbMsge(formatStr(msgCannotUpdate, cCnvtExtn), msgAlert) && display message
         cb.setFocus()                           && re-establish form focus
         return (Void)                           && terminate the update
      ENDIF

      select Project                             && open the project file
      zap                                        && make sure it's empty

      DO CASE                                    && evaluate the file type

      CASE cCnvtExtn = "PRG" .AND. cTitle = msgConvertPrg2Wfm && prg to wfm...
         cTitl = cTitle                          && set the title to a public variable (problems with the editor control...)
         cFile = cCnvtFile                       && set the file name to a public variable
         
         hEditWin = new p2wEditForm()            && launch a text editor object
         hEditWin.txtEdit.DataLink = "FILE " + cFile
         hEditWin.Text = formatStr( hEditWin.Text, upper(parsePath((cCnvtFile))) + ".PRG")
         hEditWin.nBegLine = 0
         hEditWin.nEndLine = 0
         
         hEditWin.open()                         && open the editor object

      CASE cCnvtExtn = "PRG" .AND. cTitle = msgConvertPrg2Mnu && prg to mnu...
         cTitl = cTitle                          && set the title to a public variable (problems with the editor control...)
         cFile = cCnvtFile                       && set the file name to a public variable
         
         hEditWin = new p2mEditForm()            && launch a text editor object
         hEditWin.txtEdit.DataLink = "FILE " + cFile
         hEditWin.Text = formatStr( hEditWin.Text, upper(parsePath((cCnvtFile))) + ".PRG")
         hEditWin.nBegLine = 0
         hEditWin.nEndLine = 0

         hEditWin.open()                         && open the editor object

      CASE cCnvtExtn = "FMT"                     && fmt to wfm...
         setDBWHelp()                            && switch back to dBASE's help
         cVueFile = getFile("*.DBF",  formatStr(msgDataView, trim(upper(parsePath((cCnvtFile)) + ".WFM"))), True, False)
         setCBHelp()                             && switch back to CB's help
         IF .NOT. empty(cVueFile)
            cWfmFile = getDestFile("WFM", parsePath((cCnvtFile)) + ".WFM")  && prompt for the destination file
            IF .NOT. empty(cWfmFile)             && if a file was selected or entered
               append blank                      && add a new fmt->wfm record
               fmt2wfm(cTitle, cCnvtFile, cVueFile, cWfmFile, "", 0, 10000) && create form objects
            else                                 && no entry or selected file...
               cb.setfocus()                     && make sure the app is in focus
            ENDIF
         else                                    && no entry or selected file...
            cb.setfocus()                        && make sure the app is in focus
         ENDIF

		CASE cCnvtExtn = "FRM"                  	 && frm to rpt...
         setDBWHelp()                            && switch back to dBASE's help
         cVueFile = getFile("*.DBF", formatStr(msgDataView, trim(upper(parsePath((cCnvtFile)) + ".FRM"))), True, False)
         setCBHelp()                             && switch back to CB's help
         IF .NOT. empty(cVueFile)                && if there is a view file
            cRptFile = getDestFile("RPT", parsePath((cCnvtFile)) + ".RPT")  && prompt for the destination file
            IF .NOT. empty(cRptFile)             && if there is a dest file
               append blank                      && add a new frm->rpt record
               frm2rpt(cTitle, cCnvtFile, cVueFile, cRptFile, "") && create report objects from single frm
            else                                 && no entry or selected file...
               cb.setfocus()                     && make sure the app is in focus
            ENDIF
         else
            cb.setfocus()                        && make sure the app is in focus
         ENDIF

      CASE cCnvtExtn = "LBL"                     && lbl to rpl...
         setDBWHelp()                            && switch back to dBASE's help
         cVueFile = getFile("*.DBF", formatStr(msgDataView, trim(upper(parsePath((cCnvtFile)) + ".LBL"))), True, False)
         setCBHelp()                             && switch back to CB's help
         IF .NOT. empty(cVueFile)                && if there is a view file
            cRplFile = getDestFile("RPL", parsePath((cCnvtFile)) + ".RPL")  && prompt for the destination file
            IF .NOT. empty(cRplFile)             && if there is a dest file
               append blank                      && add a new lbl->rpl record
               lbl2rpl(cTitle, cCnvtFile, cVueFile, cRplFile, "") && create report objects from single frm
            else                                 && no entry or selected file...
               cb.setfocus()                     && make sure the app is in focus
            ENDIF
         else
            cb.setfocus()                        && make sure the app is in focus
         ENDIF

      CASE cCnvtExtn = "CAT"                     && catalog...
         append from &cCnvtFile                  && get the catalog entries
         cPath = substr(cCnvtFile, 1, rat("\", cCnvtFile))  && get the path of all the files in the CAT that are pathless
         replace all Project->path with cPath + trim(Project->path) for at(":", Project->path) = 0
         cCatName = parsePath((cCnvtFile))       && get the catalog name only
         clear typeahead                         && clear the keyboard buffer in case someone has touched the keyboard while the conversion process starts up
         go top                                  && start at the first record

         DO WHILE .NOT. eof() .and. lastkey() <> 27 && look at every catalog item
            cCnvtFile = trim(Project->path)      && get the file name from the catalog
            cCnvtExtn = cCnvtFile                && copy the file name
            cCnvtExtn = getExtension(cCnvtExtn)  && derive the file extension

            DO CASE                              && evaluate the file type

            CASE cCnvtExtn = "FMT"               && fmt to wfm...
               cWfmFile = substr(cCnvtFile, 1, at(".", cCnvtFile)) + "WFM"
               cVueFile = getCatFile()           && look for a view file
               IF empty(cVueFile)                && if there's no view in the cat file
                  setDBWHelp()                   && switch back to dBASE's help
                  cVueFile = IIF(System->prmpView = True, getFile("*.DBF", "Select Database View For " + trim(upper(parsePath((cCnvtFile)) + ".FMT")), True, False), "")
                  setCBHelp()                    && switch back to CB's help
               ENDIF
               fmt2wfm(cTitle, (cCnvtFile), (cVueFile), (cWfmFile), (cCatName), 0, 10000) && create form objects

            CASE cCnvtExtn = "FRM"               && frm to rpt...
               cRptFile = substr(cCnvtFile, 1, at(".", cCnvtFile)) + "RPT"
               cVueFile = getCatFile()           && look for a view file
               IF empty(cVueFile)                && if there's no view in the cat file
                  setDBWHelp()                   && switch back to dBASE's help
                  cVueFile = IIF(System->prmpView = True, getFile("*.DBF", "Select Database View For " + trim(upper(parsePath((cCnvtFile)) + ".FRM")), True, False), "")
                  setCBHelp()                    && switch back to CB's help
               ENDIF
               IF .NOT. empty(cVueFile)          && if we have a view file...
                  frm2rpt(cTitle, (cCnvtFile), (cVueFile), (cRptFile), (cCatName)) && create report objects
               ENDIF

            CASE cCnvtExtn = "LBL"               && lbl to rpl...
               cRplFile = substr(cCnvtFile, 1, at(".", cCnvtFile)) + "RPL"
               cVueFile = getCatFile()           && look for a view file
               IF empty(cVueFile)                && if there's no view in the cat file
                  setDBWHelp()                   && switch back to dBASE's help
                  cVueFile = IIF(System->prmpView = True, getFile("*.DBF", "Select Database View For " + trim(upper(parsePath((cCnvtFile)) + ".LBL")), True, False), "")
                  setCBHelp()                    && switch back to CB's help
               ENDIF
               IF .NOT. empty(cVueFile)          && if we have a view file...
                  lbl2rpl(cTitle, (cCnvtFile), (cVueFile), (cRplFile), (cCatName)) && create label objects
               ENDIF

            ENDCASE
            select Project
            skip                                 && get the next catalog item
         ENDDO

		ENDCASE
   else                                          && no entry or selected file...
      cb.setfocus()                              && make sure the app is in focus
	ENDIF

RETURN (Void)

FUNCTION getDestFile(cExtension, cDefFile)
   local cDestFile
   local cTest
   setDBWHelp()                                  && switch back to DBW's help
   cDestFile = ""
   DO WHILE True
      cDestFile = putFile(trim(msgSaveTo) + "...", IIF(empty(cDefFile), "*." + cExtension, cDefFile))  && select a new file name
      IF file(cDestFile)                         && does the file name exist?
         IF cbDialog(formatStr(msgFileExists, upper(parsePath((cDestFile))) + "." + cExtension), msgAlert) = True
            exit
         else
            cDestFile = ""
         ENDIF
      else
         exit
      ENDIF
   ENDDO
   IF at(".", cDestFile) = 0 .AND. len(cDestFile) > 0
      cDestFile = cDestFile + "." + cExtension
   ENDIF
   setCBHelp()                                   && switch back to CB's help
RETURN (cDestFile)

FUNCTION getCatFile
   local cFileName, ;
         nCode,     ;
         cTest, ;
         nCurrRecd
   setDBWHelp()                                  && switch back to DBW's help
   nCurrRecd = recno()                           && save the current record pointer
   nCode = Project->code                         && save the catalog item's code value
   locate for Project->code == nCode .AND. upper(Project->type) == "DBF"
   IF .NOT. found()                              && if a link cannot be made in the cat file
      locate for Project->code == nCode .AND. upper(Project->type) == "QBE"
      IF .NOT. found()
         cFileName = ""                          && return null value
      else
         cFileName = upper(trim(Project->path))
      ENDIF
   else                                          && otherwise, return the file name...
      cFileName = upper(trim(Project->path))
   ENDIF
   go nCurrRecd                                  && return to the original cat line
   setCBHelp()                                   && switch back to CB's help
RETURN (cFileName)

&&& *************************************************************************
&&& PRG Builder Functions
&&& *************************************************************************
#include "p2wedit.wfm"
#include "p2medit.wfm"

&&& *************************************************************************
&&& Code Generation Display
&&& *************************************************************************
#include "dispgen.wfm"

FUNCTION prg2mnu(cTitle, cPrgFile, cMnuFile, cCatName, nBeg, nEnd)

   local   cSrceLine, ;
           cMenuName, ;
           c1stWord, ;
           c2ndWord, ;
           c3rdWord, ;
           cRow, ;
           cCol, ;
           nBarObjs, ;
           nPadObjs, ;
           nSelObjs, ;
           cMnuName, ;
           cTitleFile

   declare aMenuStru[100]

   clear typeahead                               && clear the keyboard buffer in case someone has touched the keyboard while the conversion process starts up

   * create the generation status display form
   cTitleFile = IIF(empty(cCatName), "", upper(cCatName) + ".CAT::") + upper(parsePath((cPrgFile))) + ".PRG"
   fDispGen = new dispGenForm()
   fDispGen.Text = formatStr( fDispGen.Text, cTitleFile )

   fDispGen.txtObjects.text = prgBarObjects      && define the object labels
   fDispGen.getObjects.text = prgPadObjects
   fDispGen.boxObjects.text = prgSelectObjects

   && set the srce file/dest file names on the status display screen...
   fDispGen.txtSrcFile.text = upper(parsePath((cPrgFile))) + ".PRG"
   fDispGen.txtDstFile.text = upper(parsePath((cMnuFile))) + ".MNU"
   fDispGen.txtMsgeRead.text = msgReading
   fDispGen.txtReadPcntDone.text = "80%"         && show read percent at 80% done...
   fDispGen.txtReadPcntDone.Visible = True       && make the read pcnt done object visible

   *-------------------------------------
   *-- Open the form to display the stats
   *-------------------------------------
   fDispGen.open()
   fDispGen.setFocus()
   
   appe memo Project->srceForm from (cPrgFile) overwrite  && read the txt file into a memo field
   replace Project->destForm with " "            && clear the dest name field
   cMenuName = parsePath((cPrgFile))             && save the form name

   fDispGen.txtReadPcntDone.text = "100%"
   fDispGen.txtMsgeReadDone.Visible = True
   fDispGen.txtMsgeGenr.text = prgGenMenuCode
   fDispGen.txtGenrPcntDone.Visible = True

   && get the stats on the incoming form
   replace Project->srceFile with cPrgFile
   replace Project->srceLines with memlines(Project->srceForm, 254)
   replace Project->srceDate  with fdate(cPrgFile)
   replace Project->srceTime  with ftime(cPrgFile)

   && generate the form and class definitions
   genHeader("Form", (parsePath((cMnuFile))), ".MNU")
   writeLine(False, "Parameter FormObj", "", "")
   * writeLine(False, "set procedure to program(1) additive", "", "")
   writeLine(False, "new " + cMenuName + "(FormObj, " + chr(34) + "Root" + chr(34) + ")", "", "")

   *** No problem to here...

   nBarObjs = 0                                  && set all object counters to zero...
   nPadObjs = 0
   nSelObjs = 0
   cTemp = ""                                    && initialize line continuation memvar

   nPadNumb = 0                                  && set the pad number
   nPopNumb = 0                                  && set the popup number
   nCurrLine = nBeg                              && initialize source file counter...
   * loop through all lines in the source prg file
   DO WHILE at(chr(13), Project->srceForm, nCurrLine) > 0 .AND. lastkey() <> 27 .AND. nCurrLine <= nEnd
      fDispGen.txtSrcLine.text = ltrim(trim(str(nCurrLine, 5)))
      IF nCurrLine = 1
         cSrceLine = ltrim(trim(substr(Project->srceForm, 1, at(chr(13), Project->srceForm) - 1)))
      else
         nStart    = at(chr(13), Project->srceForm, nCurrLine - 1) + 2
         nLength   = (at(chr(13), Project->srceForm, nCurrLine) - 1) - (nStart - 1)
         IF nLength > 0
            cSrceLine = ltrim(trim(substr(Project->srceForm, nStart, nLength)))
         else
            nCurrLine = nCurrLine + 1            && increment line counter
            loop
         ENDIF
      ENDIF

      IF at(chr(38) + chr(38), cSrceLine) > 1    && parse off any same-line comments
         cSrceLine = trim(substr(cSrceLine, 1, at(chr(38) +  chr(38), cSrceLine) - 1))
      ENDIF

      fDispGen.txtGenrPcntDone.text = IIF( ((nCurrLine / Project->srceLines) * 100) - 7 > 0, ltrim(str(((nCurrLine / Project->srceLines) * 100) - 7, 3, 0)) + "%", "0%")
      fDispGen.txtObjs.text = ltrim(str(nBarObjs, 3, 0))
      fDispGen.getObjs.text = ltrim(str(nPadObjs, 3, 0))
      fDispGen.boxObjs.text = ltrim(str(nSelObjs, 3, 0))

      * if this line is continued, compile the parseable line into cTemp...
      IF substr(cSrceLine, len(cSrceLine), 1) = ";"
         cTemp = cTemp + ltrim(substr(cSrceLine, 1, at(";", cSrceLine) - 1))
         nCurrLine = nCurrLine + 1               && increment the source file line counter
         loop                                    && get the next physical line
      ENDIF

      IF len(trim(cTemp)) > 0                    && if we've assebled a continuation line at this point...
         cSrceLine = cTemp                       && put the logical line into the parsing variable
         cTemp = ""                              && reset the continuation line memvar
      ENDIF

      * if there is a menu-oriented statement on the line...
      IF upper(substr(cSrceLine, 1, 4)) = "DEFI" .or. upper(substr(cSrceLine, 1, 7)) = "ON SELE"
         * continue the parsing process...
      else                                       && there is nothing here worth parsing
         nCurrLine = nCurrLine + 1               && increment the source file line counter
         loop                                    && parse the next line
      ENDIF

      nCurrLine = nCurrLine + 1                  && increment the source file line counter
      store "" to c1stWord, c2ndWord, c3rdWord   && initialize token variables

      &&&
      &&& - parse the first three tokens
      &&&
		IF " " $ cSrceLine
			 c1stWord  = upper(trim(substr(cSrceLine, 1, at(" ", cSrceLine) - 1)))
			 cSrceLine = ltrim(substr(cSrceLine, at(" ", cSrceLine) + 1))
		ENDIF

      IF len(cSrceLine) > 1 .and. " " $ cSrceLine
         c2ndWord  = upper(trim(substr(cSrceLine, 1, at(" ", cSrceLine) - 1)))
         cSrceLine = ltrim(substr(cSrceLine, at(" ", cSrceLine) + 1))
      ENDIF
      IF len(cSrceLine) > 1 .and. " " $ cSrceLine
         c3rdWord  = upper(trim(substr(cSrceLine, 1, at(" ", cSrceLine) - 1)))
         cSrceLine = ltrim(substr(cSrceLine, at(" ", cSrceLine) + 1))
      ENDIF

      DO CASE                                    && look at the pased tokens

      &&& - Define Menu ...
      CASE c1stWord = "DEFI" .AND. c2ndWord = "MENU"
         cMnuName = c3rdWord                     && save the menu name from the current line

         nIndent = 0                             && reset the indent level
         writeLine(True, "CLASS " + cMenuName + "(FormObj, Name) OF MENU(FormObj, Name)", "", "define the menu class")
         writeLine(False, "", "", "")
         writeLine(True, "this.MDI        = .F.", "+", "MDI...")
         writeLine(True, "this.Text       = " + chr(34) + upper(cMenuName) + chr(34), "", "window title")
         writeLine(True, "this.Width      = 80.00", "", "set the width to full screen")
         writeLine(True, "this.Top        = 00.00", "", "set the row position")
         writeLine(True, "this.Left       = 00.00", "", "set the column position")
         writeLine(True, "this.Height     = 25.00", "", "set the height to full screen")
         writeLine(True, "this.Minimize = .F.", "", "freeze the form")
         writeLine(True, "this.Maximize = .F.", "", "freeze the form")
         writeLine(False, "", "", "")

      &&& - Define Pad ...
      CASE c1stWord = "DEFI" .AND. c2ndWord = "PAD"
         nPadNumb = nPadNumb + 1
         aMenuStru[nPadNumb] = c3rdWord
         nPadObjs = nPadObjs + 1
         cPrompt  = ltrim(substr(cSrceLine, at(" PROM", upper(cSrceLine))))
         cPrompt  = ltrim(substr(cPrompt, at(" ", cPrompt)))
         cDelim   = substr(cPrompt, 1, 1)
         cPrompt  = ltrim(parseLabel(cPrompt, c3rdWord))
         nIndent  = System->indLevel             && reset the indent level
         writeLine(True, "DEFINE MENU " + c3rdWord + " OF this" + ";", "", "create a menu pad")
         writeLine(False, "PROPERTY ;", "+", "establish the properties of the pad")
         IF " MESS" $ upper(cSrceLine)
            cMessage = substr(cSrceLine, at(" MESS", upper(cSrceLine)) + 1)
            cMessage = ltrim(substr(cMessage, at(" ", cMessage)))
            IF chr(38) + chr(38) $ cMessage
               cMessage = trim(substr(cMessage, 1, at(chr(38) + chr(38), cMessage) - 1))
            ENDIF
            writeLine(False, "statusMessage " + cMessage + ",;", "", "status message")
         ENDIF
         writeLine(False, "text " + chr(34) + "&" + cPrompt + chr(34), "", "establish the menu bar text")
         writeLine(False, "", "", "")

      &&& - Define Popup ...
      CASE c1stWord = "DEFI" .AND. c2ndWord = "POPU"
         nPopNumb = nPopNumb + 1

      &&& - Define Bar ...
      CASE c1stWord = "DEFI" .AND. c2ndWord = "BAR"
         nBarObjs = nBarObjs + 1
         cPadName = ltrim(substr(cSrceLine, at(" OF ", upper(cSrceLine)) + 4))
         cPadname = ltrim(substr(cPadName, 1, at(" ", cPadname) - 1))
         cPrompt  = ltrim(substr(cSrceLine, at(" PROM", upper(cSrceLine))))
         cPrompt  = ltrim(substr(cPrompt, at(" ", cPrompt)))
         cDelim   = substr(cPrompt, 1, 1)
         cPrompt  = ltrim(parseText(cPrompt))
         nIndent  = System->indLevel             && reset the indent level
         writeLine(True, "DEFINE MENU mnu" + c3rdWord + " OF this." + aMenuStru[nPopNumb] + ";", "", "establish a menu bar")
         writeLine(False, "PROPERTY ;", "+", "establish the properties")
         IF " MESS" $ upper(cSrceLine)
            cMessage = substr(cSrceLine, at(" MESS", upper(cSrceLine)) + 1)
            cMessage = ltrim(substr(cMessage, at(" ", cMessage)))
            cMessage = parseText(cMessage)
            writeLine(False, "statusMessage " + cMessage + ",;", "", "status message")
         ENDIF

         IF " SKIP" $ upper(cSrceLine)           && if skip is in the menu line
            IF substr(cPrompt, 1, 1) $ cbDelimiters  && we have a string there as well
               writeLine(False, "text " + cPrompt + ",;", "", "set the bar text and hot key")
               writeLine(False, "enabled .F.", "", "disable this prompt")
            else                                 && assume it's a separator
               writeLine(False, "separator .T.", "", "add a separator")
            ENDIF
         else                                    && otherwise, it's just a prompt...
            writeLine(False, "text " + cPrompt, "", "set the bar text and hot key")
         ENDIF

         writeLine(False, "", "", "")

      &&& - On Selection Bar...
      CASE c1stWord = "ON" .AND. "SELE" $ c2ndWord .AND. c3rdWord = "BAR"
         nSelObjs   = nSelObjs + 1               && increment the object counter
         cPadName   = ltrim(substr(cSrceLine, at(" OF ", upper(cSrceLine)) + 4))
         cPadname   = ltrim(substr(cPadName, 1, at(" ", cPadname) - 1))
         cBarName   = "mnu" + ltrim(substr(cSrceLine, 1, at(" ", cSrceLine) - 1))
         cCodeBlock = ltrim(substr(cSrceLine, at(cPadName, cSrceLine)))
         cCodeBlock = ltrim(substr(cCodeBlock, at(" DO ", upper(cCodeBlock)) + 3))
         nIndent    = System->indLevel           && reset the indent level
         writeLine(False, "* this." + cMenuName + "." + cPadname + "." + cBarName + ".onclick = " + cCodeBlock, "", "attach the bar event to the bar")

      ENDCASE

   ENDDO                                         && parse the next line

   nIndent = 0                                   && reset the indent to column 1
   writeLine(False, "", "", "")                  && write a blank line
   writeLine(True, "ENDCLASS", "", "")           && close the class construct
   writeLine(False, "", "", "")                  && write a blank line

   IF lastkey() <> 27                            && if the user never pressed ESCape
      fDispGen.txtGenrPcntDone.text = "100%"     && update the status display form
      fDispGen.txtMsgeGenrDone.Visible = True
      fDispGen.txtMsgeWrit.text = msgWriting
      fDispGen.txtWritPcntDone.visible = True

      &&& - save the stats on the outgoing form
      IF System->currDire = True
         replace Project->destFile with parsePath((cMnuFile)) + ".MNU"
      else
         replace Project->destFile with cMnuFile
      ENDIF
      replace Project->srceLines with nCurrLine
      replace Project->destLines with memlines(Project->destForm, 254)
      replace Project->destDate  with date()
      replace Project->destTime  with time()
      replace Project->destObjs  with nBarObjs + nPadObjs + nSelObjs

      copy memo Project->destForm to &cMnuFile   && create the MNU file on disk
      fDispGen.txtWritPcntDone.text = "100%"     && update the percentage status
      fDispGen.txtMsgeWritDone.Visible = True    && show the completed status

      IF .NOT. empty(cCatName)                   && if this is a single file
         fDispGen.close()                        && kill the status display form
         hideStatusObjs()                        && hide status display objects
      else
         fDispGen.pCancel.text = mnuOk                 && change the button to an OK button
         fDispGen.pCancel.upBitMap = "resource #20"    && change the bitmap
      ENDIF

   ENDIF

RETURN (Void)

&&& *************************************************************************
&&& FMT Builder Functions
&&& *************************************************************************
FUNCTION fmt2wfm(cTitle, cFmtFile, cVueFile, cWfmFile, cCatName, nBeg, nEnd)

   * declare all necessary local's...
   local   cSrceLine,   ;
           cFormName,   ;
           c1stWord,    ;
           c2ndWord,    ;
           c3rdWord,    ;
           cRow,        ;
           cCol,        ;
           nTxtObjs,    ;
           nGetObjs,    ;
           nBoxObjs,    ;
           nPage,       ;
           cTitleFile
           
   lvoid = 0

   * create a status display form
   cTitleFile = IIF(empty(cCatName), "", upper(cCatName) + ".CAT::") + upper(parsePath((cFmtFile))) + IIF(".PRG" $ upper(cFmtFile), ".PRG", ".FMT")
   fDispGen = new dispGenForm()
   fDispGen.Text = formatStr( fDispGen.Text, cTitleFile )

   fDispGen.txtReadPcntDone.Visible = True
   fDispGen.txtReadPcntDone.text = "0%"
   fDispGen.txtObjects.text  = fmtSayObjects     && update status display objects
   fDispGen.getObjects.text  = fmtGetObjects
   fDispGen.boxObjects.text  = fmtBoxObjects

   && display various status indicators
   fDispGen.txtSrcFile.text  = upper(parsePath((cFmtFile))) + IIF(".PRG" $ upper(cFmtFile), ".PRG", ".FMT")
   fDispGen.txtDstFile.text  = upper(parsePath((cWfmFile))) + ".WFM"
   fDispGen.txtMsgeRead.text = msgReading

   *-------------------------------------
   *-- Open the form to display the stats
   *-------------------------------------
   fDispGen.open()
   fDispGen.setFocus()
   
   &&& - store the source form to a memo field and empty the previous generation
   appe memo Project->srceForm from (cFmtFile) overwrite  && read the fmt file into a memo field
   replace Project->srceForm with chr(13) + chr(10) additive
   replace Project->destForm with " "            && make sure the dest memo is empty
   cFormName = parsePath((cFmtFile))             && parse off the path to the selected fmt file

   &&& - get the stats on the incoming form
   replace Project->srceFile with cFmtFile
   replace Project->srceLines with memlines(Project->srceForm, 254)
   replace Project->srceDate  with fdate(cFmtFile)
   replace Project->srceTime  with ftime(cFmtFile)
   fDispGen.txtReadPcntDone.text = "100%"

   &&& - loop through the memo looking for box statements
   clear typeahead                               && make sure nothing has happend at the keyboard
   nCurrLine = IIF(nBeg = 0, 1, nBeg)            && initialize the physical line counter

   IF " TO " $ upper(Project->srceForm) .AND. nBeg = 0 .AND. ".FMT" $ upper(cFmtFile)
      DO WHILE at(chr(13), Project->srceForm, nCurrLine) > 0 .AND. lastkey() <> 27 .AND. nCurrLine <= nEnd
         lVoid = inkey()
         fDispGen.txtSrcLine.text = ltrim(trim(str(nCurrLine, 5)))
         IF nCurrLine = 1
            cSrceLine = ltrim(trim(substr(Project->srceForm, 1, at(chr(13), Project->srceForm) - 1)))
         else
            nStart    = at(chr(13), Project->srceForm, nCurrLine - 1) + 2
            nLength   = (at(chr(13), Project->srceForm, nCurrLine) - 1) - (nStart - 1)
            IF nLength > 0
               cSrceLine = ltrim(trim(substr(Project->srceForm, nStart, nLength)))
            else
               nCurrLine = nCurrLine + 1         && increment line counter
               loop
            ENDIF
         ENDIF
         IF substr(cSrceLine, 1, 1) = "@" .AND. " TO " $ upper(cSrceLine)
            replace Project->tempForm with cSrceLine + chr(13) + chr(10) additive
         else
            replace Project->destForm with cSrceLine + chr(13) + chr(10) additive
         ENDIF
         nCurrLine = nCurrLine + 1               && increment line counter
      ENDDO

      * rebuild the fmt file *
      replace Project->srceForm with Project->tempForm + chr(13) + chr(10) + Project->destForm + chr(13) + chr(10)
      replace Project->destForm with " "
      replace Project->tempForm with " "

   ENDIF

   fDispGen.txtMsgeReadDone.Visible = True       && update various status indicators
   fDispGen.txtMsgeGenr.text = fmtGenFormCode
   fDispGen.txtGenrPcntDone.Visible = True

   &&& - generate the form and class definitions
   genHeader("Form", (parsePath((cWfmFile))), ".WFM")
   writeLine(False, "LOCAL f", "","declare a memvar for the form")
   writeLine(False, "", "", "")
   writeLine(False, "f = new " + cFormName + "()", "", "create the instance of the form")
   writeLine(False, "f.open()", "", "open the form")
   writeLine(False, "", "", "")
   writeLine(False, "CLASS " + cFormName + " of form", "", "create a new class of form")
   writeLine(False, "this.Text       = " + chr(34) + upper(cFormName) + chr(34), "+", "")
   IF .NOT. empty(cVueFile)
      writeLine(False, "this.View       = " + chr(34) + cVueFile + chr(34), "", "")
   ENDIF
   writeLine(False, "this.Width      = 126.5", "", "")
   writeLine(False, "this.Top        = 00.00", "", "")
   writeLine(False, "this.Left       = 00.00", "", "")
   writeLine(False, "this.Height     = 24.00", "", "")
   writeLine(False, "this.Minimize = .F.", "", "")
   writeLine(False, "this.Maximize = .F.", "", "")  && write a blank line
   writeLine(False, "", "", "")

   nTxtObjs = 0                                  && initilize the object counter variables
   nGetObjs = 0
   nBoxObjs = 0

   cTemp = ""                                    && initialize the continuation line memvar
   nCurrLine = IIF(nBeg = 0, 1, nBeg)            && initialize the physical line counter
   nPage = 0

   &&&
   &&& - loop through all the lines in the fmt file
   &&&
   DO WHILE at(chr(13), Project->srceForm, nCurrLine) > 0 .AND. lastkey() <> 27 .AND. nCurrLine <= nEnd
      lVoid = inkey()
      fDispGen.txtSrcLine.text = ltrim(trim(str(nCurrLine, 5)))
      IF nCurrLine = 1
         cSrceLine = ltrim(trim(substr(Project->srceForm, 1, at(chr(13), Project->srceForm) - 1)))
      else
         nStart    = at(chr(13), Project->srceForm, nCurrLine - 1) + 2
         nLength   = (at(chr(13), Project->srceForm, nCurrLine) - 1) - (nStart - 1)
         IF nLength > 0
            cSrceLine = ltrim(trim(substr(Project->srceForm, nStart, nLength)))
         else
            nCurrLine = nCurrLine + 1            && increment line counter
            loop
         ENDIF
      ENDIF

      IF at(chr(38) + chr(38), cSrceLine) > 1    && parse off any same-line comments
         cSrceLine = trim(substr(cSrceLine, 1, at(chr(38) + chr(38), cSrceLine) - 1))
      ENDIF

      fDispGen.txtGenrPcntDone.text = IIF( ((nCurrLine / Project->srceLines) * 100) - 7 > 0, ltrim(str(((nCurrLine / Project->srceLines) * 100) - 7, 3, 0)) + "%", "0%")
      fDispGen.txtObjs.text = ltrim(str(nTxtObjs, 3, 0))
      fDispGen.getObjs.text = ltrim(str(nGetObjs, 3, 0))
      fDispGen.boxObjs.text = ltrim(str(nBoxObjs, 3, 0))

	  	* if the last character in the line is a continuation character...
      IF substr(cSrceLine, len(cSrceLine), 1) = ";"
         cTemp = cTemp + ltrim(substr(cSrceLine, 1, at(";", cSrceLine) - 1))
         nCurrLine = nCurrLine + 1               && increment the source file line counter
         loop
      ENDIF

      IF len(trim(cTemp)) > 0                    && if we've created a continued line
         cSrceLine = cTemp                       && set the logical line variable to the complete line
         cTemp = ""                              && reset the continuation line memvar
      ENDIF

      IF substr(cSrceLine, 1, 1) = "@"           && if the line is an @...SAY or @...GET
         * continue the parsing process...
      else                                       && there is nothing here worth parsing
         IF upper(substr(ltrim(cSrceLine), 1, 4)) = "READ"
            nPage = nPage + 1
         ENDIF
         nCurrLine = nCurrLine + 1               && increment the source file line counter
         loop                                    && parse the next line
      ENDIF

      store "" to c1stWord, c2ndWord, c3rdWord   && initialize the token memvars

      * parse out up to three tokens (if possible)
      IF len(cSrceLine) > 1 .and. " " $ cSrceLine
			 c1stWord  = upper(trim(substr(cSrceLine, 1, at(" ", cSrceLine) - 1)))
			 cSrceLine = ltrim(substr(cSrceLine, at(" ", cSrceLine) + 1))
		ENDIF

      IF len(cSrceLine) > 1 .and. " " $ cSrceLine

         && - fix the line if there are spaces between row/col numbers
         cTemp = ""
         FOR n = 1 TO len(cSrceLine)
            IF substr(cSrceLine, n, 1) = ","
               cTemp = trim(cTemp) + "," + ltrim(substr(cSrceLine, at(",", cSrceLine) + 1))
               n = len(cSrceLine) + 2
            else
               cTemp = cTemp + substr(cSrceLine, n, 1)
            ENDIF
         NEXT
         cSrceLine = cTemp
         cTemp = ""

         c2ndWord  = upper(trim(substr(cSrceLine, 1, at(" ", cSrceLine) - 1)))
         cSrceLine = ltrim(substr(cSrceLine, at(" ", cSrceLine) + 1))

      ENDIF

      IF len(cSrceLine) > 1 .and. " " $ cSrceLine
         c3rdWord  = upper(trim(substr(cSrceLine, 1, at(" ", cSrceLine) - 1)))
         cSrceLine = ltrim(substr(cSrceLine, at(" ", cSrceLine) + 1))
      ENDIF

      nCurrLine = nCurrLine + 1                  && increment the source file line counter

      &&&
      &&& - evaluate the tokens...
      &&&

      DO CASE
      CASE c1stWord = "@"

         &&& - get the row and column coordinates for SAY's and GET's
         cRow = trim(ltrim(substr(c2ndWord, 1, at(",", c2ndWord) - 1)))
         cRow = ltrim(str(val(cRow) + IIF(nPage = 0, 0, (nPage * 25)), 5))
         cCol = trim(ltrim(substr(c2ndWord, at(",", c2ndWord) + 1)))

         cRow = ltrim(str(val(cRow) * 1.01, 6, 2))
         cCol = ltrim(str(val(cCol) * 1.59, 6, 2))

         DO CASE

         &&& - SAY statement...
         CASE c3rdWord = "SAY"                   && @..SAY statements...
            IF " GET " $ upper(cSrceLine)
               nTxtObjs = nTxtObjs + 1           && increment the text object counter
               cDelim   = substr(cSrceLine, 1, 1)&& determine the text delimiter
               cLabel   = parseText(substr(cSrceLine, 1, at(" GET ", upper(cSrceLine))))
               nLength  = 1.59 * (IIF(substr(cLabel, 1, 1) $ cbDelimiters, len(cLabel) - 2, cbDefExprLen))
               cColor   = parseColor(upper(cSrceLine), "")
               nIndent  = System->indLevel       && reset the indent level
               writeLine(True, "DEFINE TEXT txtObj" + ltrim(str(nTxtObjs, 3)) + " OF THIS;", "", "define a text object")
               writeLine(False, "Property;", "+", "establish the properties")
               IF substr(cLabel, 1, 1) $ cbDelimiters  && is this an expression
                  nEndDelim = at(substr(cLabel, 1, 1), substr(cLabel, 2)) + 1
                  IF len(trim(substr(cLabel, nEndDelim + 1))) = 0
                     writeLine(False, "Text          " + cLabel + ",;", "+", "set the text of the object")
                  else
                     writeLine(False, "OnOpen        {;this.text = " + cLabel + "},;", "+", "set the expr of the text object")
                  ENDIF
               else
                  writeLine(False, "OnOpen        {;this.text = " + cLabel + "},;", "+", "set the expr of the text object")
               ENDIF
               IF .NOT. empty(cColor)
                  writeLine(False, "ColorNormal   " + chr(34) + cColor + chr(34) + ",;", "", "set the color property")
               ENDIF
               IF asc(substr(cLabel, 2, 1)) > 127
                  writeLine(False, "fontName      " + chr(34) + "Terminal" + chr(34) + ",;", "", "terminal font")
               ENDIF
               writeLine(False, "Top           " + cRow + ",;", "", "row position")
               writeLine(False, "Left          " + cCol + ",;", "", "column position")
               writeLine(False, "Width         " + ltrim(str(nLength, 6, 2)), "", "string length")
               writeLine(False, "", "", "")

               *************************
               * create the GET object *
               *************************
               cCol = str(val(cCol) + nLength + 1.59, 6, 2)
               cSrceLine = ltrim(substr(cSrceLine, at(" GET ", upper(cSrceLine)) + 5))
               nGetObjs  = nGetObjs + 1             && increment the object counter
               cGetField = ltrim(cSrceLine)
               IF at(" ", cGetField) > 0
                  cGetField = substr(cGetField, 1, at(" ", cGetField) - 1)
               ENDIF
               IF " MESS" $ upper(cSrceLine)        && if there is a message clause, parse it...
                  cMessage  = ltrim(substr(cSrceLine, at(" MESS", upper(cSrceLine))))
                  cMessage  = ltrim(substr(cMessage, at(" ", cMessage)))
                  cDelim    = substr(cMessage, 1, 1)
                  cMessage  = ltrim(parseLabel(cMessage, c3rdWord))
               else
                  cMessage  = ""
               ENDIF
               IF " FUNC" $ upper(cSrceLine)        && if there is a function clause, parse it...
                  cFunction = ltrim(substr(cSrceLine, at(" FUNC", upper(cSrceLine))))
                  cFunction = ltrim(substr(cFunction, at(" ", cFunction)))
                  cFunction = parseText(cFunction)
               else
                  cFunction = ""
               ENDIF
               IF " VALI" $ upper(cSrceLine)        && if there is a valid clause, parse it...
                  IF " REQU" $ upper(cSrceLine)
                     cValid    = ltrim(substr(cSrceLine, at(" REQU", upper(cSrceLine))))
                     cRequired = ".T."
                  else
                     cValid    = ltrim(substr(cSrceLine, at(" VALI", upper(cSrceLine))))
                     cRequired = ""
                  ENDIF
                  cValid    = ltrim(substr(cValid, at(" ", cValid)))
                  IF " ERRO" $ upper(cValid)
                     cError = ltrim(substr(cValid, at(" ERRO", upper(cValid))))
                     cError = ltrim(substr(cError, at(" ", cError)))
                     cError = parseText(cError)
                  else
                     cError = ""
                  ENDIF
                  cValid = parseText(cValid)
               else
                  cValid    = ""
                  cRequired = ""
                  cError    = ""
               ENDIF

               cPicture  = parsePicture(upper((cSrceLine)))
               nLength   = 1.59 * (len(cPicture))
               cColor    = parseColor(upper(cSrceLine), "")
               nIndent   = System->indLevel         && reset the indent level

               &&&
               &&& - determine which type of object to build
               &&&
               DO CASE

               &&& - checkbox...
               CASE System->logCheck = True .AND. substr(cPicture, 1, 1) $ "L~Y~"
                  writeLine(True, "DEFINE CHECKBOX getObj" + ltrim(str(nGetObjs, 3)) + " OF THIS;", "", "create check box object")
                  writeLine(False, "Property;",   "+", "set the properties")
                  writeLine(False, "Width         3,;", "+", "establish the width")
                  writeLine(False, "Top           " + ltrim(str(val(cRow) - .4, 6, 2)) + ",;", "", "the row position")
                  writeLine(False, "Left          " + cCol + ",;", "", "the column position")
                  writeLine(False, "Height        1.5,;", "", "the height of the check box")
                  IIF(.not. empty(cMessage), writeLine(False, "StatusMessage " + chr(34) + cMessage + chr(34) + ",;", "", "status message"), .F.)
                  IF .NOT. empty(cColor)
                     writeLine(False, "ColorNormal   " + chr(34) + cColor + chr(34) + ",;", "", "set the color")
                  ENDIF
                  writeLine(False, "DataLink      " + chr(34) + cGetField + chr(34), "", "establish the data link")
                  writeLine(False, "", "", "")

               &&& - entryfield...
               OTHERWISE
                  writeLine(True, "DEFINE ENTRYFIELD getObj" + ltrim(str(nGetObjs, 3)) + " OF THIS;", "", "create an entry field")
                  writeLine(False, "Property;",   "+", "set the properties")
                  IF .NOT. empty(cFunction)
                     writeLine(False, "Function      " + cFunction + ",;", "", "set the function property")
                  ENDIF
                  IF .NOT. empty(cValid)
                     writeLine(False, "Valid         {;" + cValid + "},;", "", "set the valid event property")
                  ENDIF
                  IF .NOT. empty(cRequired)
                     writeLine(False, "ValidRequired .T.,;", "", "set the valid required property")
                  ENDIF
                  IF .NOT. empty(cError)
                     writeLine(False, "ValidErrorMsg " + cError + ",;", "", "set the valid error message")
                  ENDIF
                  writeLine(False, "Top           " + cRow + ",;", "", "the row position")
                  writeLine(False, "Left          " + cCol + ",;", "", "the column position")
                  IIF(.not. empty(cMessage), writeLine(False, "StatusMessage " + chr(34) + cMessage + chr(34) + ",;", "", "status message"), .F.)
                  IF .NOT. empty(cColor)
                     writeLine(False, "ColorNormal   " + chr(34) + cColor + chr(34) + ",;", "", "set the color")
                  ENDIF
                  IF nLength > 0
                     writeLine(False, "Picture       " + chr(34) + cPicture + chr(34) + ",;", "", "establish the picture")
                  ENDIF
                  writeLine(False, "DataLink      " + chr(34) + cGetField + chr(34), "", "establish the data link")
                  writeLine(False, "", "", "")
               ENDCASE

            else                                 && this is just a simple SAY statement
               nTxtObjs = nTxtObjs + 1           && increment the text object counter
               cDelim   = substr(cSrceLine, 1, 1)&& determine the text delimiter
               cLabel   = parseText(cSrceLine)
               nLength  = 1.59 * (IIF(substr(cLabel, 1, 1) $ cbDelimiters, len(cLabel) - 2, cbDefExprLen))
               cColor   = parseColor(upper(cSrceLine), "")
               nIndent  = System->indLevel       && reset the indent level
               writeLine(True, "DEFINE TEXT txtObj" + ltrim(str(nTxtObjs, 3)) + " OF THIS;", "", "define a text object")
               writeLine(False, "Property;", "+", "establish the properties")
               IF substr(cLabel, 1, 1) $ cbDelimiters  && is this an expression
                  nEndDelim = at(substr(cLabel, 1, 1), substr(cLabel, 2)) + 1
                  IF len(trim(substr(cLabel, nEndDelim + 1))) = 0
                     writeLine(False, "Text          " + cLabel + ",;", "+", "set the text of the object")
                  else
                     writeLine(False, "OnOpen        {;this.text = " + cLabel + "},;", "+", "set the expr of the text object")
                  ENDIF
               else
                  writeLine(False, "OnOpen        {;this.text = " + cLabel + "},;", "+", "set the expr of the text object")
               ENDIF
               IF .NOT. empty(cColor)
                  writeLine(False, "ColorNormal   " + chr(34) + cColor + chr(34) + ",;", "", "set the color property")
               ENDIF
               IF asc(substr(cLabel, 2, 1)) > 127
                  writeLine(False, "fontName      " + chr(34) + "Terminal" + chr(34) + ",;", "", "terminal font")
               ENDIF
               writeLine(False, "Top           " + cRow + ",;", "", "row position")
               writeLine(False, "Left          " + cCol + ",;", "", "column position")
               writeLine(False, "Width         " + ltrim(str(nLength, 6, 2)), "", "string length")
               writeLine(False, "", "", "")
            ENDIF


         &&& - GET statement...
         CASE c3rdWord = "GET"                   && @..GET statements...
               nGetObjs  = nGetObjs + 1             && increment the object counter
               cGetField = ltrim(cSrceLine)
               IF at(" ", cGetField) > 0
                  cGetField = substr(cGetField, 1, at(" ", cGetField) - 1)
               ENDIF
               IF " MESS" $ upper(cSrceLine)        && if there is a message clause, parse it...
                  cMessage  = ltrim(substr(cSrceLine, at(" MESS", upper(cSrceLine))))
                  cMessage  = ltrim(substr(cMessage, at(" ", cMessage)))
                  cDelim    = substr(cMessage, 1, 1)
                  cMessage  = ltrim(parseLabel(cMessage, c3rdWord))
               else
                  cMessage  = ""
               ENDIF
               IF " FUNC" $ upper(cSrceLine)        && if there is a function clause, parse it...
                  cFunction = ltrim(substr(cSrceLine, at(" FUNC", upper(cSrceLine))))
                  cFunction = ltrim(substr(cFunction, at(" ", cFunction)))
                  cFunction = parseText(cFunction)
               else
                  cFunction = ""
               ENDIF
               IF " VALI" $ upper(cSrceLine)        && if there is a valid clause, parse it...
                  IF " REQU" $ upper(cSrceLine)
                     cValid    = ltrim(substr(cSrceLine, at(" REQU", upper(cSrceLine))))
                     cRequired = ".T."
                  else
                     cValid    = ltrim(substr(cSrceLine, at(" VALI", upper(cSrceLine))))
                     cRequired = ""
                  ENDIF
                  cValid    = ltrim(substr(cValid, at(" ", cValid)))
                  IF " ERRO" $ upper(cValid)
                     cError = ltrim(substr(cValid, at(" ERRO", upper(cValid))))
                     cError = ltrim(substr(cError, at(" ", cError)))
                     cError = parseText(cError)
                  else
                     cError = ""
                  ENDIF
                  cValid = parseText(cValid)
               else
                  cValid    = ""
                  cRequired = ""
                  cError    = ""
               ENDIF

               cPicture  = parsePicture(upper((cSrceLine)))
               nLength   = 1.59 * (len(cPicture))
               cColor    = parseColor(upper(cSrceLine), "")
               nIndent   = System->indLevel         && reset the indent level

               &&&
               &&& - determine which type of object to build
               &&&
               DO CASE

               &&& - checkbox...
               CASE System->logCheck = True .AND. substr(cPicture, 1, 1) $ "L~Y~"
                  writeLine(True, "DEFINE CHECKBOX getObj" + ltrim(str(nGetObjs, 3)) + " OF THIS;", "", "create check box object")
                  writeLine(False, "Property;",   "+", "set the properties")
                  writeLine(False, "Width         3,;", "+", "establish the width")
                  writeLine(False, "Top           " + ltrim(str(val(cRow) - .4, 6, 2)) + ",;", "", "the row position")
                  writeLine(False, "Left          " + cCol + ",;", "", "the column position")
                  writeLine(False, "Height        1.5,;", "", "the height of the check box")
                  IIF(.not. empty(cMessage), writeLine(False, "StatusMessage " + chr(34) + cMessage + chr(34) + ",;", "", "status message"), .F.)
                  IF .NOT. empty(cColor)
                     writeLine(False, "ColorNormal   " + chr(34) + cColor + chr(34) + ",;", "", "set the color")
                  ENDIF
                  writeLine(False, "DataLink      " + chr(34) + cGetField + chr(34), "", "establish the data link")
                  writeLine(False, "", "", "")

               &&& - entryfield...
               OTHERWISE
                  writeLine(True, "DEFINE ENTRYFIELD getObj" + ltrim(str(nGetObjs, 3)) + " OF THIS;", "", "create an entry field")
                  writeLine(False, "Property;",   "+", "set the properties")
                  IF .NOT. empty(cFunction)
                     writeLine(False, "Function      " + cFunction + ",;", "", "set the function property")
                  ENDIF
                  IF .NOT. empty(cValid)
                     writeLine(False, "Valid         {;" + cValid + "},;", "", "set the valid event property")
                  ENDIF
                  IF .NOT. empty(cRequired)
                     writeLine(False, "ValidRequired .T.,;", "", "set the valid required property")
                  ENDIF
                  IF .NOT. empty(cError)
                     writeLine(False, "ValidErrorMsg " + cError + ",;", "", "set the valid error message")
                  ENDIF
                  writeLine(False, "Top           " + cRow + ",;", "", "the row position")
                  writeLine(False, "Left          " + cCol + ",;", "", "the column position")
                  IIF(.not. empty(cMessage), writeLine(False, "StatusMessage " + chr(34) + cMessage + chr(34) + ",;", "", "status message"), .F.)
                  IF .NOT. empty(cColor)
                     writeLine(False, "ColorNormal   " + chr(34) + cColor + chr(34) + ",;", "", "set the color")
                  ENDIF
                  IF nLength > 0
                     writeLine(False, "Picture       " + chr(34) + cPicture + chr(34) + ",;", "", "establish the picture")
                  ENDIF
                  writeLine(False, "DataLink      " + chr(34) + cGetField + chr(34), "", "establish the data link")
                  writeLine(False, "", "", "")
               ENDCASE

         &&& - rectangle object...
         CASE c3rdWord = "TO"                    && @..TO statements...
            nBoxObjs = nBoxObjs + 1              && increment the object counter

            &&& - get the 2nd row and column coordinates
            cRow2   = trim(ltrim(substr(cSrceLine, 1, at(",", cSrceLine) - 1)))
            cCol2   = trim(ltrim(substr(cSrceLine, at(",", cSrceLine) + 1)))
            cCol2   = trim(substr(cCol2, 1, IIF(at(" ", cCol2) > 0, at(" ", cCol2) - 1, len(cCol2))))
            cRow2 = ltrim(str(val(cRow2) * 1.01, 6, 2))
            cCol2 = ltrim(str(val(cCol2) * 1.59, 6, 2))
            cHeight = ltrim(str((val(cRow2) - val(cRow)) + 1, 3))
            cWidth  = ltrim(str((val(cCol2) - val(cCol)) + 1, 3))
            cColor  = ""                         && disable any incoming box colors
            nIndent = System->indLevel           && reset the indent level

            IF (val(cRow) = val(cRow2)) .OR. (val(cCol) = val(cCol2))
               writeLine(True, "DEFINE LINE lineObj" + ltrim(str(nBoxObjs, 3)) + " OF THIS;", "", "create a line object")
               writeLine(False, "Property;", "+", "establish the properties")
               IF .NOT. empty(cColor)
                  writeLine(False, "ColorNormal   " + chr(34) + cColor + chr(34) + ",;", "+", "set the color")
                  writeLine(False, "Bottom        " + cRow2 + ",;", "", "the bottom row of the line")
               else
                  writeLine(False, "Bottom        " + cRow2 + ",;", "+", "the bottom row of the line")
               ENDIF
               writeLine(False, "Right         " + cCol2 + ",;", "", "the right col of the line")
               writeLine(False, "Top           " + cRow + ",;", "", "the top row of the line")
               writeLine(False, "Left          " + cCol + "", "", "the left column of the line")
            else
               writeLine(True, "DEFINE RECTANGLE boxObj" + ltrim(str(nBoxObjs, 3)) + " OF THIS;", "", "create a box object")
               writeLine(False, "Property;", "+", "establish the properties")
               writeLine(False, "Text          " + chr(34) + chr(34) + ",;", "+", "the text of the box")
               IF .NOT. empty(cColor)
                  writeLine(False, "ColorNormal   " + chr(34) + cColor + chr(34) + ",;", "", "set the color")
               ENDIF
               writeLine(False, "Height        " + cHeight + ",;", "", "the height of the box")
               writeLine(False, "Width         " + cWidth + ",;", "", "the width of the box")
               writeLine(False, "Top           " + cRow + ",;", "", "row position")
               writeLine(False, "Left          " + cCol + "", "", "column position")
            ENDIF

            writeLine(False, "", "", "")

         &&& - panel object...
         CASE c3rdWord = "FILL"                  && @..TO statements...
            nBoxObjs = nBoxObjs + 1              && increment the object counter

            &&& - get the 2nd row and column coordinates
            cRow2   = ltrim(substr(cSrceLine, at(" TO ", upper(cSrceLine)) + 4))
            cRow2   = trim(ltrim(substr(cRow2, 1, at(",", cRow2) - 1)))
            cCol2   = trim(ltrim(substr(cSrceLine, at(",", cSrceLine) + 1)))
            cCol2   = trim(substr(cCol2, 1, at(" ", cCol2) - 1))
            cRow2   = ltrim(str(val(cRow2) * 1.01, 6, 2))
            cCol2   = ltrim(str(val(cCol2) * 1.59, 6, 2))
            cHeight = ltrim(str((val(cRow2) - val(cRow)) + 1, 3))
            cWidth  = ltrim(str((val(cCol2) - val(cCol)) + 1, 3))

            cColor  = parseColor(upper(cSrceLine), "")

            nIndent = System->indLevel           && reset the indent level
            writeLine(True, "DEFINE RECTANGLE boxObj" + ltrim(str(nBoxObjs, 3)) + " OF THIS;", "", "define a box fill object")
            writeLine(False, "Property;", "+", "establish the properties")
            IF .NOT. empty(cColor)
               writeLine(False, "ColorNormal   " + chr(34) + cColor + chr(34) + ",;", "+", "set the color of the fill region")
               writeLine(False, "Height        " + cHeight + ",;", "", "the height")
            else
               writeLine(False, "Height        " + cHeight + ",;", "+", "the height")
            ENDIF
            writeLine(False, "Width         " + cWidth + ",;", "", "the width")
            writeLine(False, "Top           " + cRow + ",;", "", "row position")
            writeLine(False, "Left          " + cCol + "", "", "column position")
            writeLine(False, "", "", "")         && write a blank line

         ENDCASE

      ENDCASE

   ENDDO

   nIndent = System->indLevel                    && reset the indent to one level
   IF nPage > 0                                  && if this is a multi-page form
      writeLine(True, "this.scrollBar = 1", "", "") && set the scroll bar property for multi-page form
      writeLine(False, "", "", "")               && write a blank line
   ENDIF

   nIndent = 0                                   && reset the indent to column 1
   writeLine(True, "ENDCLASS", "", "")           && close the class construct

   IF lastkey() <> 27                            && if the user never pressed ESCape
      fDispGen.txtGenrPcntDone.text = "100%"     && update the status display
      fDispGen.txtMsgeGenrDone.Visible = True
      fDispGen.txtMsgeWrit.text = msgWriting
      fDispGen.txtWritPcntDone.visible = True

      &&& - save the stats on the outgoing form
      IF System->currDire = True
         replace Project->destFile with parsePath((cWfmFile)) + ".WFM"
      else
         replace Project->destFile with cWfmFile
      ENDIF
      replace Project->srceLines with nCurrLine
      replace Project->destLines with memlines(Project->destForm, 254)
      replace Project->destDate  with date()
      replace Project->destTime  with time()
      replace Project->destObjs  with nTxtObjs + nGetObjs + nBoxObjs

      cFormName = trim(Project->destFile)        && derive the WFM name
      copy memo Project->destForm to &cWfmFile   && write the WFM to disk
      fDispGen.txtWritPcntDone.text = "100%"     && update the percentage status
      fDispGen.txtMsgeWritDone.Visible = True    && show the completed status

      IF .NOT. empty(cCatName)                   && if this is a single file
         fDispGen.close()                        && kill the status display form
         hideStatusObjs()                        && hide status display objects
      else
         fDispGen.pCancel.text = mnuOk                 && change the button to an OK button
         fDispGen.pCancel.upBitMap = "resource #20"    && change the bitmap
      ENDIF

   ENDIF

RETURN (lVoid)

FUNCTION hideStatusObjs
   fDispGen.txtSrceFile.Visible     = False      && hide all the status objects
   fDispGen.txtSrceLine.Visible     = False
   fDispGen.txtDestFile.Visible     = False
   fDispGen.txtDestLine.Visible     = False
   fDispGen.txtObjs.Visible         = False
   fDispGen.getObjs.Visible         = False
   fDispGen.boxObjs.Visible         = False
   fDispGen.txtMsgeGenr.Visible     = False
   fDispGen.txtMsgeWrit.Visible     = False
   fDispGen.txtMsgeReadDone.Visible = False
   fDispGen.txtMsgeGenrDone.Visible = False
   fDispGen.txtMsgeWritDone.Visible = False
   fDispGen.txtReadPcntDone.Visible = False
   fDispGen.txtGenrPcntDone.Visible = False
   fDispGen.txtWritPcntDone.Visible = False
RETURN (Void)

FUNCTION genHeader(cType, cName, cExtn)
   writeLine(False, " ***********************************************", "", "")
   writeLine(False, " ***       Visual dBASE Component Builder    ***", "", "")
   writeLine(False, " ***              " + cType + " Generation            ***", "", "")
   writeLine(False, " ***" + space(20 - (len(cName)/2)) + upper(cName) + cExtn + space(18 - ((len(cName) + 1)/2)) + "***", "", "")
   writeLine(False, " ***      Created: " + dtoc(date()) + " @ " + time() + "       ***", "", "")
   writeLine(False, " ***********************************************", "", "")
   writeLine(False, "", "", "")
RETURN (Void)

FUNCTION parseLabel(cSrceLine)
   IF substr(cSrceLine, 1, 1) $ cbDelimiters
      cLabel = substr(cSrceLine, at(cDelim, cSrceLine) + 1)
      cLabel = substr(cLabel, 1, at(cDelim, cLabel) - 1)
   else
      cLabel = parseText(ltrim(cSrceLine))
   ENDIF
RETURN (trim(cLabel))

FUNCTION parseText(cSrceLine)
   cLabel = ltrim(substr(cSrceLine, 1))       && get the rest of the line as the expression
   IF chr(38) + chr(38) $ cSrceLine
      cSrceLine = trim(substr(cSrceLine, 1, at(chr(38) + chr(38), cSrceLine) - 1))
   ENDIF
   IF " PICT" $ upper(cLabel)                 && if there's a picture statement
      cLabel = ltrim(substr(cLabel, 1, at( " PICT", upper(cLabel)) - 1))
   ENDIF
   IF " FUNC" $ upper(cLabel)                 && if there's a function statement
      cLabel = ltrim(substr(cLabel, 1, at( " FUNC", upper(cLabel)) - 1))
   ENDIF
   IF " COLO" $ upper(cLabel)                 && if there's a color statement
      cLabel = ltrim(substr(cLabel, 1, at( " COLO", upper(cLabel)) - 1))
   ENDIF
   IF " MESS" $ upper(cLabel)                 && if there's a message statement
      cLabel = ltrim(substr(cLabel, 1, at( " MESS", upper(cLabel)) - 1))
   ENDIF
   IF " SKIP" $ upper(cLabel)                 && if there's a skip statement
      cLabel = ltrim(substr(cLabel, 1, at( " SKIP", upper(cLabel)) - 1))
   ENDIF
   IF " ERRO" $ upper(cLabel)                 && if there's an error statement
      cLabel = ltrim(substr(cLabel, 1, at( " ERRO", upper(cLabel)) - 1))
   ENDIF
RETURN (trim(cLabel))

FUNCTION parsePicture(cSrceLine)
   IF " PICT" $ upper(cSrceLine)
      cPicture = ltrim(substr(cSrceLine, at(" PICT", upper(cSrceLine))))
      cPicture = ltrim(substr(cPicture, at(" ", cPicture)))
      cDelimChr = substr(cPicture, 1, 1)
      cPicture = substr(cPicture, 2)
      cPicture = substr(cPicture, 1, at(cDelimChr, cPicture) - 1)
   else
      cPicture = ""
   ENDIF
RETURN (cPicture)

FUNCTION parseColor(cSrceLine, cColor)
   IF " COLO" $ upper(cSrceLine)
      cColor = ltrim(substr(cSrceLine, at(" COLO", upper(cSrceLine))))
      cColor = ltrim(substr(cColor, at(" ", cColor))) + " "
      cColor = substr(cColor, 1, at(" ", cColor) - 1)
      IF "," $ cColor
         cColor = trim(substr(cColor, 1, at(",", cColor) - 1))
      ENDIF
   ENDIF
RETURN (cColor)

FUNCTION writeLine(lLineCount, cSrceCode, cTab, cComment)

   * update the status line display...
   IF lLineCount
      fDispGen.txtDstLine.text = ltrim(trim(str(val(fDispGen.txtDstLine.text) + 1, 5)))
   ENDIF

   DO CASE
   CASE cTab = "+"                               && if we're indenting further
      nIndent = nIndent + System->indLevel       && update the indent level
   CASE cTab = "-"                               && if we're backdenting...
      nIndent = nIndent - System->indLavel       && decrement the indent level
   ENDCASE

   IF System->cmntSrce = True .AND. len(cComment) > 0
      IF len(space(nIndent) + cSrceCode) >= 50
         cSrceCode = cSrceCode + "  " + chr(38) + chr(38) + " " + cComment
      else
         cSrceCode = cSrceCode + space(50 - len(space(nIndent) + cSrceCode)) + chr(38) + chr(38) + " " + cComment
      ENDIF
   ENDIF
   replace Project->destForm with space(nIndent) + cSrceCode + chr(13) + chr(10) additive

RETURN (Void)


&&& *************************************************************************
&&& Code Generation Functions
&&& *************************************************************************

*-----------------------------------
*-- Class definition for GenPerfForm
*-----------------------------------
#include "genperf.wfm"

FUNCTION setGenPref

   select System

   LOCAL fGenPerf
   fGenPref = new GenPerfForm()
   
   *--------------------------------------------------------------
   *-- Set up the values based on the fields in the System alias
   *-- to allow editing of GenPerf.wfm using the Form Designer.
   *--------------------------------------------------------------
   fGenPref.cb0.value = System->prmpView
   fGenPref.cb1.value = System->currDire
   fGenPref.cb2.value = System->cmntSrce
   fGenPref.cb3.value = System->logCheck
   fGenPref.sb1.value = System->indLevel
   
   fGenPref.readModal()

RETURN (Void)


&&& *************************************************************************
&&& Supporting Functions
&&& *************************************************************************
FUNCTION getHelp
   parameters cTopic
   help &cTopic
RETURN (Void)

FUNCTION parseElipse
   parameters cTitle
RETURN (trim(substr(cTitle, 1, at("...", cTitle) - 1)))

FUNCTION notComplete(cFeature)
   cbMsge(formatStr(msgFeatureNotComplete, cFeature), cFeature)
RETURN (Void)

FUNCTION cbMsge(cMsgeText, cTitleText)
   msgBox(cMsgeText, cTitleText, 48 + 0)
RETURN (Void)

FUNCTION cbDialog(cMsgeText, cTitleText)
RETURN (IIF(msgBox(cMsgeText, cTitleText, 32 + 4) = 6, True, False))

FUNCTION setEnvironment
   clear                                         && clear screen
   set talk off                                  && quiet the screen
   set safe off                                  && safety not necessary
   set esca off
   cDesign  = set("desi")
   cPoint   = set("poin")
   cLdCheck = set("ldch")
   cExcl    = set("excl")
   set design off
   set point to "."
   set ldcheck off
   set excl on
   set message to
   setCBHelp()
   nIndent = 0                                   && establish the starting indent level
RETURN (Void)

FUNCTION resetEnvironment
   close databases
   setDBWHelp()
   set safe on                                   && safety back on
   set talk on                                   && enable the screen
   set poin to cPoint                            && reset the point setting
   set desi &cDesign                             && reset the design state
   set ldch &cLdCheck                            && reset the ldcheck setting
   set excl &cExcl                               && reset the exclusivity state

   release nIndent,      ;                       && clean up a bit...
           fDialect,     ;
           fGenPref,     ;
           fFileSelect,  ;
           fDispGen
           
   release cbcrwapi, nbegline, nendline, cpoint, cdesign, cldcheck, ;
           cexcl, ctitl, cfile, dump, alabel, nHandle, ;
           objhead
           
RETURN (Void)

FUNCTION parsePath(cFullName)
   cFullName = substr(cFullName, rat("\", cFullName) + 1)
RETURN (lower(substr(cFullName, 1, at(".", cFullName) - 1)))

#include "aboutcb.wfm"

FUNCTION getExtension(cFileName)
   cFileName = upper(trim(right(cFileName, 4)))
RETURN (substr(cFileName, at(".", cFileName) + 1))


CLASS Band OF Object
   this.CorrBandId = 0
   this.BandType = 0
   this.GroupNum = 0
   this.BandEditor = 0
   this.Open = .T.
   this.GroupType = "0"
   this.GroupRecs = 0
   this.PrintIntro = 0
   this.NewPage = 0
   this.TextPitch = 0
   this.Quality = 0
   this.NumLines = 0
   this.Spacing = 0
   this.BandSize = 0
   this.GroupField = ""
   this.GroupExp = ""
   this.CRWSection = 0
   
   FUNCTION Print
      ? "this.CorrBandId     ", this.CorrBandId     
      ? "this.BandType       ", this.BandType       
      ? "this.GroupNum       ", this.GroupNum       
      ? "this.BandEditor     ", this.BandEditor     
      ? "this.Open           ", this.Open           
      ? "this.GroupType      ", this.GroupType      
      ? "this.GroupRecs      ", this.GroupRecs      
      ? "this.PrintIntro     ", this.PrintIntro
      ? "this.NewPage        ", this.NewPage        
      ? "this.TextPitch      ", this.TextPitch      
      ? "this.Quality        ", this.Quality        
      ? "this.NumLines       ", this.NumLines       
      ? "this.Spacing        ", this.Spacing        
      ? "this.BandSize       ", this.BandSize
      ? "this.GroupField     ", this.GroupField            
      ? "this.GroupExp       ", this.GroupExp       
   RETURN .T.
   
   FUNCTION SetSection
      DO CASE
         CASE this.BandType = 0     && Page header
            this.CRWSection = PE_HEADERSECTION
            
         CASE this.BandType = 1     && Report Intro - Ignored
            this.CRWSection = PE_HEADERSECTION + 1
            
         CASE this.BandType = 2     && Group Intro
            this.CRWSection = PE_GROUPHEADER + this.GroupNum - 1
            
         CASE this.BandType = 3     && Detail
            this.CRWSection = PE_DETAILSECTION
            
         CASE this.BandType = 4     && Group Summary
            this.CRWSection = PE_GROUPFOOTER + this.GroupNum - 1
            
         CASE this.BandType = 5     && Report Summary
            this.CRWSection = PE_GRANDTOTALSECTION
            
         CASE this.BandType = 6     && Page Footer
            this.CRWSection = PE_FOOTERSECTION
            
      ENDCASE
      
   RETURN this.CRWSection
   
   PROCEDURE dB3FillBand( nBandType, nGroupNum )
   *--------------------------------------------------------------------------
   *  DESCRIPTION
   *     Assumes that the DBF is still open in the current workarea
   *     
   *  DEPENDENCIES
   *     GlobalRpt = object that contains the global report values
   *     aDbf[]    = array of field names
   *     Bucket    = expressions and strings using in the report
   *     BuckLen[] = array of entry lengths in the bucket
   *     BuckOff[] = array of entry offsets into the bucket
   *--------------------------------------------------------------------------
      this.BandType = nBandType
      this.GroupNum = nGroupNum
      this.BandEditor = 0
      IF nBandType = btGroupSummary .AND. .NOT. GlobalRpt.IsTotal
         this.Open = .F.
      ELSE
         IF nBandType = btDetail .AND. GlobalRpt.GroupSummary = "Y"
            this.Open = .F.
         ELSE
            this.Open = .T.
         ENDIF
      ENDIF

      IF nBandType = btGroupIntro
         IF nGroupNum = 1
            nBuckPtr = GlobalRpt.GroupPtr + 1
            IF GlobalRpt.EjectAfterGroup = "Y"
               this.PrintIntro = 1
            ENDIF
         ELSE
            nBuckPtr = GlobalRpt.SubGroupPtr + 1
         ENDIF
         cGroupOn = SUBSTR( bucket, BuckOff[ nBuckPtr ] + 1, BuckLen[ nBuckPtr ] - 1 )
         IF ASCAN( aDbf, UPPER( cGroupOn ) ) > 0
            this.GroupType = "0"                && This is a field to group on
            this.GroupField = cGroupOn
         ELSE
            this.GroupType = TYPE( cGroupOn )
            this.GroupExp = cGroupOn
         ENDIF
      ENDIF

      IF GlobalRpt.DoubleSpace = "Y"      
         this.Spacing = 2
      ELSE
         this.Spacing = 1
      ENDIF
      
      this.SetSection()
   RETURN
            
   
ENDCLASS

CLASS DB4Descriptor OF OBJECT
PARAMETER  pcDB4File

   this.cVersion = ""
   this.nVersion = 0
   this.nType = 0             && 7 frm, 11 lbl, 18 scr
   this.nNumBands = 0         && forms and labels always 1
   this.PageFlag = 0          && Page heading flag
   this.nNumFields = 0        && number of fields
   this.nHeight = 0           && Label height
   this.nWidth = 0            && Label width
   this.nLeftMargin = 0       && label left margin
   this.nRowSpace = 0         && space between rows of labels
   this.nColSpace = 0         && space between columns of labels
   this.nColumns = 0          && number of columns of labels
   this.LabRows = 0           && number of labels down the page
   this.PrintTemp = ""        && Print template name
   this.FileName = ""         && Report, form, or label name
   this.cComment = ""         && Design description
   this.DB4File = pcDB4File   && File name to open
   this.nTempRec = 0
   
   FUNCTION ReadDB4Head
   *--------------------------------------------------------------------------
   *  DESCRIPTION
   *     Read in the design descriptor for a dBASE IV LBL or FRM file
   *     and set the member values.  Leaves the file open unless the
   *     version is incorrect.  Returns the file handle if all was ok,
   *     otherwise return 0.
   *--------------------------------------------------------------------------
      PRIVATE nHandle      
      nHandle = fopen(this.DB4File, "R")                && open the file
      IF nHandle > 0

         this.cVersion = left(fread(nHandle, 41), 40)
         this.nVersion = asc(fread(nHandle, 1))
         this.nType = asc(fread(nHandle, 1))
         fseek(nHandle, 13, 1)                      && skip 13 bytes
         
         this.nNumBands = asc(fread(nHandle, 1))

         IF this.cVersion <> "dBASE IV Generic Design File Version 1.0"
            IF ASC( LEFT( this.cVersion, 1 ) ) = 2
               *-------------------------------------------------
               *-- This could be a dBASE III Plus report or label
               *-------------------------------------------------
               IF RIGHT( this.DB4File, 3 ) = "LBL"
                  *-------------------------------------------------------
                  *-- It's a label file, rewind the file and read it again
                  *-------------------------------------------------------
                  FSEEK( nHandle, 1, 0 )           && back to the position after version
                  FSEEK( nHandle, 60, 1 )          && skip over the 60 byte remark area
                  this.cVersion    = sDB3PLUS
                  this.nVersion    = 3
                  this.nType       = 11
                  this.nNumBands   = 1
                  this.nHeight     = word2num(fread(nHandle, 2))
                  this.nWidth      = word2num(fread(nHandle, 2))
                  this.nLeftMargin = word2num(fread(nHandle, 2))
                  this.nRowSpace   = word2num(fread(nHandle, 2))
                  this.nColSpace   = word2num(fread(nHandle, 2))
                  this.nColumns    = word2num(fread(nHandle, 2))
                  this.nNumFields  = this.nHeight
                  
                  select Project
                  this.nTempRec = recno()
                  use
                  
                  RETURN nHandle
               ELSE
                  IF RIGHT( this.DB4File, 3 ) = "FRM"
                     *---------------------
                     *-- It's a report file
                     *---------------------
                     this.cVersion    = sDB3PLUS
                     this.nVersion    = 3
                     this.nType       = 7
                     
                     *---------------------------------------------------------------
                     *-- The rest of the report information is at the end of the file
                     *-- so we need to exit here and do the rest of the read in
                     *-- procedure dB3FrmFill.
                     *---------------------------------------------------------------
                     select Project
                     this.nTempRec = recno()
                     use
                     RETURN nHandle
                     
                  ELSE
                     *--------------------
                     *-- Unknown file type
                     *--------------------
                     nHandle = 0
                     return(nHandle)
                  ENDIF
               ENDIF
               
            ELSE
               nHandle = 0
               return(nHandle)
            ENDIF
         ENDIF

         select Project
         this.nTempRec = recno()
         use

         this.PageFlag = ASC(FREAD(nHandle, 1))
         this.nNumfields = word2num(fread(nHandle, 2))
      
         fseek(nHandle, 24, 1)                      && skip 24 bytes...
      
         *-----------------------------------------------
         *-- Get label information from design descriptor
         *-----------------------------------------------
         this.nHeight     = word2num(fread(nHandle, 2))
         this.nWidth      = word2num(fread(nHandle, 2))
         this.nLeftMargin = word2num(fread(nHandle, 2))
         this.nRowSpace   = word2num(fread(nHandle, 2))
         this.nColSpace   = word2num(fread(nHandle, 2))
         this.nColumns    = ASC(FREAD(nHandle, 1))
         this.LabRows     = ASC(FREAD(nHandle, 1))
         fseek(nHandle, 4, 1)                       && skip 4 bytes... Reserved

         this.PrintTemp = readstring(nHandle)            && Throw away ... Print template name
         this.FileName = readstring(nHandle)             && Throw away ... Report/Label name
         this.cComment = readstring(nHandle)             && Design description
      ENDIF
      
   RETURN  nHandle

   PROCEDURE DumpDB4Head
      clear
      if dump
         ? "  cVersion:", this.cVersion
         ? "  nVersion:", this.nVersion
         ? "     nType:", this.nType
         ? " nNumBands:", this.nNumBands
         ? "nNumFields:", this.nNumFields
         ? "  cComment:", this.cComment
         ? "   nHeight:", this.nHeight
         ? "    nWidth:", this.nWidth
         ? "nLeftMargin:",this.nLeftMargin
         ? " nRowSpace:", this.nRowSpace
         ? " nColSpace:", this.nColSpace
         ? "  nColumns:", this.nColumns
         ? "   LabRows:", this.LabRows
         ? "  FileName:", this.FileName
         ?
      endif
   RETURN
          
   
ENDCLASS


FUNCTION frm2rpt(cTitle, cFrmFile, cDbfFile, cRptFile, cCatName)

   local  cCBViewFile
   private nHandle
   
   PRIVATE lVoid, nLine, nHandle, cChar, cString, cViewFile
   cViewFile = ""
   
   DO InitFrmLbl WITH cFrmFile, cRptFile, ".FRM", ".RPT", cCatName, cViewFile
   
   dump = .F.
   if dump
      set alternate to dump.txt
      set alternate on
   endif

   private ObjHead
   ObjHead = NEW DB4Descriptor( cFrmFile )
   nHandle = ObjHead.ReadDB4Head()

   IF nHandle = 0
      IF file(cViewFile)                      && if a CB view exists...
         delete file &cViewFile               && delete it
      ENDIF
      fclose(nHandle)
      fDispGen.close()
      cbMsge(msgNotFileFormat, msgAlert)
      return(False)
   ENDIF
   
   ObjHead.DumpDB4Head()

   *----------------------------------------------------------
   *-- Create aFields and ABands arrays by reading source file
   *----------------------------------------------------------
   PRIVATE nItmCnt, AFieldSize, lIntro, nIntroLines
   nItmCnt = 0
   AFieldSize = 0
   lIntro = .F.
   nIntroLines = 0
   
   fDispGen.txtReadPcntDone.Visible = True       && make the read pcnt done object visible

   IF ObjHead.cVersion = sDB3PLUS
      DO dB3FrmFill WITH cDbfFile
   ELSE
      DO FillArrays
   ENDIF


   fDispGen.txtMsgeReadDone.Visible = True
   fDispGen.txtReadPcntDone.text = "100%"      && make the read pcnt done object visible
   fDispGen.txtGenrPcntDone.Visible = True
   fDispGen.txtGenrPcntDone.text    = "10%"      && update the status display form
   fDispGen.txtMsgeGenr.Visible     = True
   fDispGen.txtMsgeGenr.text        = frmGenReportCode

   IF ObjHead.nNumFields > 0                             && if there are fields to convert...
      
      IF dump
         ? lineno(), "Fields to process!"
      ENDIF
      

      IF "QBE" $ upper(cDbfFile)                 && if we're dealin with a QBE
         set view to (cDbfFile)                  && determine the file name
         cDbf = substr(dbf(), 3)
         cDbf = substr(cDbf, 1, at(".", cDbf) - 1)
         IF file(cViewFile)                      && if a CB view exists...
            set view to &cViewFile               && restore the CB view environment
         ENDIF
      ENDIF

      fDispGen.txtGenrPcntDone.text    = "95%"   && update the status display form
      select 40

      if dump
         ? lineno(), "**** Open print engine for RPT"
      endif
      lOpenCrw = peOpenEngine()                  && open the CRW engine
      nCrwHndl = peNewPrintJob(ansi(cDbfFile), 1, "")  && engage a print job

      *-----------------------------------------
      *-- Add a grand total section if necessary
      *-----------------------------------------
      FOR nBand = 1 TO ObjHead.nNumBands
         IF aBands[ nBand ].CRWSection = PE_GRANDTOTALSECTION
            lVoid = peAddGrandTotalSection(nCrwHndl)
            if dump
               ? lineno(), "Added grand total section"
            endif
            exit
         ENDIF
      NEXT

      *---------------------------------------------------------------------------      
      *-- Add the group bands as needed.  Only need to add one per group band pair
      *---------------------------------------------------------------------------      
      lGrp = .F.
      FOR nBand = 1 TO ObjHead.nNumBands
         IF aBands[nBand].BandType = 2    && Group intro

            if dump
               ? lineno(), "Adding group intro band:", aBands[nBand].GroupNum-1
            endif

            IF .NOT. EMPTY(aBands[nBand].GroupField)
               lVoid = peAddGroup(nCrwHndl, ;
                                 aBands[nBand].GroupNum-1, ;
                                 "{" + ansi(parsePath((cDbfFile)) + "." + parsePath((cDbfFile)) + "->" + aBands[nBand].GroupField + "}"),;
                                 0,;
                                 PE_SF_ASCENDING )
            ELSE
               IF .NOT. EMPTY(aBands[nBand].GroupExp)
                  *--------------------------------------------------------------------
                  *-- Need to create a formula for the group expression before using it
                  *--------------------------------------------------------------------
                  cFormName = "CRW_BAND_" + LTRIM( STR( nBand ) )
                  lOk = peNewFormula( nCrwHndl, ANSI( cFormName ), ansi( aBands[nBand].GroupExp ) )
                  
                  
                  lOk = peAddGroup( nCrwHndl, ;
                                    aBands[nBand].GroupNum-1, ;
                                    "{@" + ansi(cFormName + "}"),;
                                    0,;
                                    PE_SF_ASCENDING )
                  IF .NOT. lOk
                     *----------------------------------------------------------
                     *-- Could not create the group, so display an error message
                     *----------------------------------------------------------
                     nAns = MSGBOX( formatStr( msgBadGroupText, aBands[nBand].GroupExp ), ;
                                    msgAlert, ;
                                    0 + 16 )
                  ENDIF
                  
               ENDIF                  
            ENDIF   
            lGrp = .T.
         ENDIF
         
         *------------------------------
         *-- Mark closed bands as hidden
         *------------------------------
         IF aBands[nBand].BandType = 1       && But skip over the report intro band
            LOOP
         ENDIF
         
         IF .NOT. aBands[nBand].Open
            IF dump
               ? "Hide band:", nband, "CRWSection:", aBands[ nBand ].CRWSection, "band type:", aBands[ nBand ].BandType
            ENDIF
            
            cPointer = makeint(16) + ;          && StructSize
                       chr(0)+chr(0) + ;        && Visible
                       chr(255)+chr(255) + ;    && newPageBefore
                       chr(255)+chr(255) + ;    && newPageAfter
                       chr(255)+chr(255) + ;    && keepTogether
                       chr(255)+chr(255) + ;    && suppressBlankLines
                       chr(255)+chr(255) + ;    && resetPageAfter
                       chr(255)+chr(255)        && printAtBottomOfPage
            lOk = peSetSectionFormat( nCrwHndl, aBands[ nBand ].CRWSection, ANSI(cPointer) )
            IF .NOT. lOk .AND. dump
               ? "***" + lineno() + "peSetSectionFormat() call failed to hide section."
            ENDIF
            
         ELSE
            IF dump
               ? "Show band:", nband, "CRWSection:", aBands[ nBand ].CRWSection, "band type:", aBands[ nBand ].BandType
            ENDIF
            cPointer = makeint(16) + ;          && StructSize
                       chr(1)+chr(0) + ;        && Visible
                       chr(255)+chr(255) + ;    && newPageBefore
                       chr(255)+chr(255) + ;    && newPageAfter
                       chr(255)+chr(255) + ;    && keepTogether
                       chr(255)+chr(255) + ;    && suppressBlankLines
                       chr(255)+chr(255) + ;    && resetPageAfter
                       chr(255)+chr(255)        && printAtBottomOfPage
            lOk = peSetSectionFormat( nCrwHndl, aBands[ nBand ].CRWSection, ANSI(cPointer) )
            IF .NOT. lOk .AND. dump
               ? lineno(), "peSetSectionFormat() call failed to show section."
            ENDIF
            
         ENDIF
         
      NEXT

      IF dump
         ? lineno(), "Determine the number of lines in each of the bands"
      ENDIF

      nPgHeadLines = 0      
      *------------------------------------      
      *-- Fill in blank lines for each band
      *------------------------------------      
      FOR nBand = 1 TO ObjHead.nNumBands
         nBandType = aBands[ nBand ].BandType
         IF nBandType = 1           && Skip over the Report Intro when adding lines
            aBands[ nBand ].CRWSection = PE_HEADERSECTION
            LOOP
         ENDIF
         
         IF dump
            aBands[nBand].Print()
         ENDIF
         
         IF nBandType = 0 .AND. lIntro                      && If Page footer and Report Intro are combined
            nLines = aBands[ nBand ].NumLines + nIntroLines && Add the Intro lines to the page footer lines
            nPgHeadLines = aBands[ nBand ].NumLines         && Save the Report Intro row offset for performance         
         ELSE
            nLines = aBands[ nBand ].NumLines
         ENDIF
         
         *-------------------------------------------------------------------------
         *-- Adjust the number of lines in the band to account for the line spacing
         *-------------------------------------------------------------------------
         nLines = nLines * aBands[ nBand ].Spacing
         
         nSection  = aBands[ nBand ].CRWSection
         nLineNo   = 1
         
         *-------------------------------------------------------------------
         *-- Subtract out the default lines already in the band based on type
         *-------------------------------------------------------------------
         DO CASE
            CASE nBandType = 0 .OR. nBandType = 6     && Page header or Page Footer
               nLines = nLines - 3
               nLineNo = 3
            OTHERWISE
               nLines = nLines - 1
         ENDCASE
         
         FOR nAdd = 1 TO nLines
            lOk = peAddLineToSection (nCrwHndl, nSection, nLineNo)
            nCrwLines = peGetNLinesInSection( nCrwHndl, nSection )
            IF dump
               ? lineno(), "Added line to band:", nBand, " section:", nSection
            ENDIF
            
            nLineNo = nLineNo + 1
         NEXT
         
      NEXT
         

      IF dump
         ? lineno(), "Add fields to the report"
      ENDIF
      
      nField = 1
      nFldHndl = 1                               && set the field handle to a positive value
      DO WHILE nField <= ObjHead.nNumFields              && loop through all the fields in the report
         
         IF dump
            ? lineno(), "aFields[" + ltrim( str( nField ) ) + ", 1] =", aFields[ nField, 1 ]
            ? lineno(), "aFields[" + ltrim( str( nField ) ) + ",14] =", aFields[ nField, 14 ]
            ?
         ENDIF

         *-------------------------------------         
         *-- Look for fields that are temporary
         *-------------------------------------         
         IF TYPE( "aFields[nField, 14]" ) # "N"    && Is the Band value not set
            IF dump
               ? lineno(), "Skipped, band not set!"
            ENDIF            
            nField = nField + 1
            LOOP
         ELSE
            IF aBands[ aFields[ nField, 14 ] ].BandType = 1  && Is this a report header
               IF lIntro
                  *----------------------------------------------------------------
                  *-- Shift the field from the Report Intro band to the page header
                  *----------------------------------------------------------------
                  aFields[ nField, 15 ] = aFields[ nField, 15 ] + nPgHeadLines
                  
               ELSE
                  *-----------------------------
                  *-- Skip the Report Intro band
                  *-----------------------------
                  IF dump
                     ? lineno(), "Skipped, report header band!"
                  ENDIF            
                  nField = nField + 1
                  LOOP
                  
               ENDIF
               
            ELSE
               *-- Don't print on rows greater that 99
               IF TYPE( "aFields[nField, 15]" ) = "N" .AND. ;
                  aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing > 90
                  IF dump
                     ? lineno(), "Skipped, rows in band exceeded!"
                  ENDIF            
                  nField = nField + 1
                  LOOP
               ENDIF
            ENDIF
            
         ENDIF
         

         DO CASE

         * dbf/memvar type fields *
         CASE aFields[nField, 2] = 0 .OR. (aFields[nField, 2] = 1 .AND. empty(aFields[nField, 12])) .OR. aFields[nField, 2] = 4
            IF "QBE" $ upper(cDbfFile)
               nFldHndl = peNewDatabaseField(nCrwHndl, upper(ansi(parsePath((cDbfFile)) + "." + cDbf + "->" + aFields[nField, 1])))
            else
               nFldHndl = peNewDatabaseField(nCrwHndl, ansi(parsePath((cDbfFile)) + "." + parsePath((cDbfFile)) + "->" + aFields[nField, 1]))
            ENDIF
            IF nFldHndl = 0
               * error inserting a field...
            else
               lSet = peSetFieldLocation( nCrwHndl, ;
                                          nFldHndl, ;
                                          getSection(aFields[nField, 14]), ;
                                          aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing, ;
                                          TwipLoc( nField ) )
               lOk  = peSetFieldWidth( nCrwHndl, ;
                                       nFldHndl, ;
                                       TwipWidth( nField ) )

            ENDIF

            *---------------------------------------------------------            
            *-- Save field handle in case it is used for a calculation
            *---------------------------------------------------------            
            aFields[nField,13] = nFldHndl
            
            IF dump
               lineno(), "Added dbf/memvar:", aFields[nField, 1]
            ENDIF
            

         * summary type fields *
         CASE aFields[nField, 2] = 2
            *------------------------------------------------------------------
            *-- Scan the afields[] array for either the field or calculation to
            *-- summarize on.  If found, use it's field handle for creating the
            *-- new summary field.  Otherwise, create a new database field.
            *-- Calc fields always have the field handle set before the summary
            *-- field is processed.
            *------------------------------------------------------------------
            nFldHndl = 0
            FOR nFld = 1 TO ObjHead.nNumFields
               *-----------------------------------------------------------------------
               *-- Does the summarize on field equal the field name or is it a count op
               *-----------------------------------------------------------------------
               IF aFields[nField,5] = aFields[nFld,1] .OR. aFields[nField,6] = 1
                  *---------------------------------------
                  *-- Is the field handle already assigned
                  *---------------------------------------
                  IF TYPE( "aFields[nFld,13]" ) = "N" .AND. aFields[nFld,13] > 0
                     nFldHndl = aFields[nFld,13]      && Set the field handle
                     EXIT
                  ENDIF
               
               ENDIF
               
            NEXT

            *------------------------------------------------------------------
            *-- If this is a summary field based on a field not already on the
            *-- report surface, create a new database field.  When CRW comes up
            *-- with the API call to hide the field, make it hidden!
            *------------------------------------------------------------------
            IF nFldHndl = 0
            *-------------------------------------------------------------------------
            *-- Determine if this is a summary based on a Database field or Calc field
            *-------------------------------------------------------------------------
               IF "QBE" $ upper(cDbfFile)
                  nFldHndl = peNewDatabaseField(nCrwHndl, ansi(parsePath((cDbfFile)) + "." + cDbf + "->" + aFields[nField, 5]))
               else
                  nFldHndl = peNewDatabaseField(nCrwHndl, ansi(parsePath((cDbfFile)) + "." + parsePath((cDbfFile)) + "->" + aFields[nField, 5]))
               ENDIF
            ENDIF
            
            IF nFldHndl = 0
               * error inserting a field...
               IF dump
                  ? lineno(), "Error creating summary field:", nField, "summ on:", aFields[nField,5]
               ENDIF
               
            else
               nSumHndl = peNewSummaryField(nCrwHndl, nFldHndl, getSection(aFields[nField, 14]), getSumType(aFields[nField, 6]))
               
               lSet = peSetFieldLocation( nCrwHndl, ;
                                          nSumHndl, ;
                                          getSection(aFields[nField, 14]), ;
                                          aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing, ;
                                          TwipLoc( nField ) )
               lOk  = peSetFieldWidth( nCrwHndl, ;
                                       nSumHndl, ;
                                       TwipWidth( nField ) )
                                       
               IF dump
                  lineno(), "Added summary type field:", aFields[nField, 5]
               ENDIF
                                          
            ENDIF
         * calc type fields *
         CASE aFields[nField, 2] = 1
            IF dump
               ? lineno(), "Calc field addition"
            ENDIF
            
            *----------------------------------------------------------
            *-- Make up a name for the calc field if one does not exist
            *----------------------------------------------------------
            IF EMPTY( aFields[ nField, 1 ] )
               aFields[ nField, 1 ] = "CRW_CALC_" + LTRIM( STR( nField ) )
            ENDIF
            
            IF dump
               ? lineno(), aFields[ nField, 1 ], "=", aFields[ nField, 12 ]
            ENDIF
            
            lFmlHndl = peNewFormula(nCrwHndl, ansi(aFields[nField, 1]), ansi(aFields[nField, 12]))
            nFldHndl = peNewFormulaField(nCrwHndl, ansi(aFields[nField, 1]))
            IF dump
               ? lineno(), "Formula added with field handle:", nFldHndl
            ENDIF
            
            IF nFldHndl = 0
               * error inserting a formula field...
            else
               lSet = peSetFieldLocation(nCrwHndl, ;
                                         nFldHndl, ;
                                         getSection(aFields[nField, 14]), ;
                                         aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing, ;
                                         TwipLoc( nField ) )
               lOk  = peSetFieldWidth( nCrwHndl, ;
                                       nFldHndl, ;
                                       TwipWidth( nField ) )
            ENDIF

            *---------------------------------------------------------            
            *-- Save field handle in case it is used for a calculation
            *---------------------------------------------------------            
            aFields[nField,13] = nFldHndl
            
            IF dump
               lineno(), "Added calc field:", aFields[nField, 12]
            ENDIF

         * predef type fields *
         CASE aFields[nField, 2] = 3
            DO CASE

            CASE aFields[nField, 8] = 2    && Recno
               nFldHndl = peNewSpecialVarField(nCrwHndl, 4)

            CASE aFields[nField, 8] = 3    && Pageno
               nFldHndl = peNewSpecialVarField(nCrwHndl, 5)

            CASE aFields[nField, 8] = 0    && Date
               nFldHndl = peNewSpecialVarField(nCrwHndl, 0)

            CASE aFields[nField, 8] = 1    && Time
               lFmlHndl = peNewFormula(nCrwHndl, ansi(aFields[nField, 1]), ansi( "TIME()" ) )
               nFldHndl = peNewFormulaField(nCrwHndl, ansi(aFields[nField, 1]))

            ENDCASE
         
            lSet = peSetFieldLocation(nCrwHndl, ;
                                      nFldHndl, ;
                                      getSection(aFields[nField, 14]), ;
                                      aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing, ;
                                      TwipLoc( nField ) )
            lOk  = peSetFieldWidth( nCrwHndl, ;
                                    nFldHndl, ;
                                    TwipWidth( nField ) )
            
            IF dump
               lineno(), "Added predefined:", aFields[nField, 1]
            ENDIF

         * text type fields *
         CASE aFields[nField, 2] = 9
            nTtlHndl = peNewTextField(nCrwHndl, ansi(aFields[nField, 1]))
            IF nTtlHndl = 0
               * error inserting a text field...
            else
               * get the position of the matching field and move the text to match it...
               lSet = peSetFieldLocation(nCrwHndl, ;
                                         nTtlHndl, ;
                                         getSection(aFields[nField, 14]), ;
                                         aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing, ;
                                         TwipLoc( nField) )
               IF TYPE( "aFields[nField,4]" ) # "N"
                  aFields[nField,4] = LEN(aFields[nField,1])
               ENDIF
               lOk  = peSetFieldWidth( nCrwHndl, ;
                                       nTtlHndl, ;
                                       TwipWidth( nField ) )
               
            ENDIF
            IF dump
               lineno(), "Added text:", aFields[nField, 1]
            ENDIF
         ENDCASE

         nField = nField + 1

      ENDDO

      IF dump
         ? lineno(), "All fields processed!"
      ENDIF
      
      fDispGen.txtGenrPcntDone.text    = "100%"  && update the status display form
      fDispGen.txtMsgeGenrDone.Visible = True
      fDispGen.txtMsgeWrit.text = msgWriting
      
      if dump
         ? lineno(), msgWriting, 
      endif
      

      IF file(cRptFile)                          && save routine for rpt files
         delete file &cRptFile
         if dump
            ? lineno(), msgWriting, "Previous report deleted"
         endif
      ENDIF

      *-----------------------------------------------------------
      *-- Use a 10 char per inch font for now, use band info later
      *-----------------------------------------------------------
      if dump
         ? lineno(), "Set the fonts for each band"
      endif
      lFontChng = peSetFont(nCrwHndl, 0, 1, ansi("Courier New"), 0, 0, 1, 12, -1, -1, -1, 0)
      FOR nBand = 1 TO ObjHead.nNumBands
         nPitch = aBands[ nBand ].TextPitch
         nCRWSect = aBands[ nBand ].CRWSection
         IF aBands[ nBand ].BandType = 1        && Ignore setting the font in the Report Intro band
            LOOP
         ENDIF
         
         DO CASE
            CASE nPitch = 0 .OR. nPitch = 3     && Pica or default
               lFontChng = peSetFont(nCrwHndl, nCRWSect, 1, ansi("Courier New"), 0, 0, 1, 12, -1, -1, -1, 0)
            CASE nPitch = 1                     && Elite
               lFontChng = peSetFont(nCrwHndl, nCRWSect, 1, ansi("Courier New"), 0, 0, 1, 10, -1, -1, -1, 0)
            CASE nPitch = 2                     && Compressed
               lFontChng = peSetFont(nCrwHndl, nCRWSect, 1, ansi("Courier New"), 0, 0, 1, 8, -1, -1, -1, 0)
         ENDCASE
      NEXT
      
      *-------------------------------------------------------------------
      *-- Adjust the margins so that 80 columns show on the design surface
      *-------------------------------------------------------------------
      if dump
         ? lineno(), "Set the page margins"
      endif
      peSetMargins( nCrwHndl, 0, 0, 0, 0 )

      if dump
         ? lineno(), "Save the print job"
      endif
      lSaveCrw = peSavePrintJob(nCrwHndl, ansi(cRptFile))
      IF lSaveCrw = False
         * error saving the report...
      ENDIF

      if dump
         ? lineno(), "Close print job"
      endif
      lClsePjb = peClosePrintJob(nCrwHndl)       && close the print job
      IF lClsePjb = False                        && was there an error?
         * error closing CRW...
      ENDIF

      &&& - update the status display...
      fDispGen.txtGenrPcntDone.text = "100%"     && update the status display
      fDispGen.txtWritPcntDone.visible = True
      fDispGen.txtWritPcntDone.text = "100%"     && update the status display
      fDispGen.txtMsgeWritDone.Visible = True

      if dump
         ? lineno(), "Restore view"
      endif
      IF file(cViewFile)                         && if a CB view exists...
         set view to &cViewFile                  && restore the CB view environment
         delete file &cViewFile                  && delete it
      ENDIF

      &&& - save the stats on the outgoing report...
      select Project
      go ObjHead.nTempRec
      if dump
         ? lineno(), "Update report stats"
      endif
      
      replace Project->destDate  with date()
      replace Project->destTime  with time()

      IF .NOT. empty(cCatName)                   && if this is a single file
         fDispGen.close()                        && kill the status display form
         hideStatusObjs()                        && hide status display objects
      else
         fDispGen.pCancel.text = mnuOk           && change the button to an OK button
         fDispGen.pCancel.upBitMap = "resource #20" && change the bitmap
      ENDIF
      
      if dump
         ? lineno(), "Process complete!"
      endif

   else                                          && no fields were found...
      cbMsge(msgNoFieldsFound, msgSystemError)   && display error message
   ENDIF

   if dump
         set alternate off
         close alternate
   endif
      

RETURN (0)
*-- EOP: Frm2Rpt

CLASS savit OF Object
   this.width  = 0
   this.space  = 0
   this.dtatyp = ""     && need to get from data file
   this.totflg = ""
   this.dec    = 0
   this.dtaptr = 0
   this.hdrptr = 0      && -1/255 if none
   
   PROCEDURE ReadFields
      this.Width  = word2num(fread(nHandle, 2))
      this.Space  = word2num(fread(nHandle, 2))
      this.DtaTyp = fread(nHandle, 1)
      this.TotFlg = fread(nHandle, 1)
      this.Dec    = word2num(fread(nHandle, 2))
      this.DtaPtr = word2num(fread(nHandle, 2))
      this.HdrPtr = word2num(fread(nHandle, 2))
   RETURN
   
ENDCLASS

PROCEDURE dB3FrmFill
PARAMETER pcDbfFile
*-----------------------------------------------------------------------------
*  DESCRIPTION
*     This routine reads in a dBASE III Plus FRM file and creates the
*     AFields[], and aBands[] arrays and fills in the rest of the ObjHead
*     properties.
*-----------------------------------------------------------------------------
   PRIVATE isTotal
   
   FSEEK( nHandle, 0, 0 )           && back to the position after version
   FSEEK( nHandle, 2, 1 )           && skip over the version   
   FSEEK( nHandle, 2, 1 )           && skip next available position in bucket
   DECLARE BuckLen[ NUMBUCK ], BuckOff[ NUMBUCK ]
   DECLARE SavFlds[ MAXFLDS ]
   
   fDispGen.txtGenrPcntDone.text    = "30%"   && update the status display form
   fDispGen.txtReadPcntDone.text    = "30%"      && make the read pcnt done object visible
   
   *------------------------------------------------------------------------
   *-- Open the DBF associated with the label in order to determine the type
   *-- of the current field or expression.
   *------------------------------------------------------------------------
   SET VIEW TO ( pcDbfFile )
   DECLARE aDbf[1]
   afields( adbf )
   aresize( adbf,alen(adbf,1), 1, 1 )

   *----------------------------
   *-- Fill in the BuckLen array
   *----------------------------
   FOR i = 1 TO NUMBUCK
      BuckLen[ i ] = word2num(fread(nHandle, 2))
   ENDFOR
   
   *----------------------------
   *-- Fill in the BuckOff array
   *----------------------------
   FOR i = 1 TO NUMBUCK
      BuckOff[ i ] = word2num(fread(nHandle, 2))
   ENDFOR

   *---------------------
   *-- Fill in the Bucket
   *---------------------
   Bucket = FREAD( nHandle, 1440 )
   
   *--------------------------------
   *-- Fill in the field information
   *--------------------------------
   isTotal = .F.
   FOR i = 1 TO MAXFLDS
      SavFlds[ i ] = NEW savit()
      SavFlds[ i ].ReadFields()
      IF SavFlds[ i ].TotFlg = "Y"
         isTotal = .T.
      ENDIF
   ENDFOR
   
   *--------------------------------------
   *-- Read in the global file information
   *--------------------------------------
   GlobalRpt = NEW Object()
   GlobalRpt.TitlePtr          = word2num(fread(nHandle, 2))
   GlobalRpt.GroupPtr          = word2num(fread(nHandle, 2))
   GlobalRpt.SubGroupPtr       = word2num(fread(nHandle, 2))
   GlobalRpt.GroupDataPtr      = word2num(fread(nHandle, 2))
   GlobalRpt.SubGroupDataPtr   = word2num(fread(nHandle, 2))
   GlobalRpt.PrintWidth        = word2num(fread(nHandle, 2))
   GlobalRpt.LinesPerPage      = word2num(fread(nHandle, 2))
   GlobalRpt.LeftMargin        = word2num(fread(nHandle, 2))
   GlobalRpt.RightMargin       = word2num(fread(nHandle, 2))
   GlobalRpt.MaxPrintFields    = word2num(fread(nHandle, 2))
   GlobalRpt.DoubleSpace       = fread(nhandle,1)
   GlobalRpt.GroupSummary      = fread(nhandle,1)
   GlobalRpt.EjectAfterGroup   = fread(nhandle,1)
   GlobalRpt.Bits              = asc(fread(nhandle,1))
   GlobalRpt.Version2          = word2num(fread(nHandle, 2))
   GlobalRpt.IsTotal           = isTotal
   GlobalRpt.PlainPage         = BITSET( GlobalRpt.Bits, 2 )
   GlobalRpt.Wide              = GlobalRpt.PrintWidth - GlobalRpt.LeftMargin - GlobalRpt.RightMargin
   
   FCLOSE( nHandle )
   
   *-----------------------------------------------------------------------------
   *-- Define the array that holds the field values based on the number of fields
   *-----------------------------------------------------------------------------
   AFieldSize = 255
   public array aFields[AFieldSize, 17]

   *-----------------------------------------------------------------------
   *-- Define the array of band objects based on the number of report bands
   *-----------------------------------------------------------------------
   nBands = 2                    && Page header + Detail band
   IF isTotal
      nBands = nBands + 1        && Add report summary
   ENDIF
   IF GlobalRpt.GroupPtr # NO3PLUSVALUE
      nBands = nBands + 2        && Add group summary bands
   ENDIF
   IF GlobalRpt.SubGroupPtr # NO3PLUSVALUE
      nBands = nBands + 2        && Add sub group summary bands
   ENDIF
   Objhead.nNumBands = nBands
   PUBLIC ARRAY aBands[ ObjHead.nNumBands ]
   
   *--------------------------------------
   *-- Fill in the report band information
   *--------------------------------------
   nBand = 1   
   aBands[nBand] = NEW Band()
   aBands[nBand].db3FillBand( btPageHeader, 0 )
   IF GlobalRpt.GroupPtr # NO3PLUSVALUE
      nBand = nBand + 1
      aBands[nBand] = NEW Band()
      aBands[nBand].db3FillBand( btGroupIntro, 1 )
      aBands[nBand].NumLines = 2
   ENDIF
   IF GlobalRpt.SubGroupPtr # NO3PLUSVALUE
      nBand = nBand + 1
      aBands[nBand] = NEW Band()
      aBands[nBand].db3FillBand( btGroupIntro, 2 )
      aBands[nBand].NumLines = 2
   ENDIF
   nBand = nBand + 1
   aBands[nBand] = NEW Band()
   aBands[nBand].db3FillBand( btDetail, 0 )
   aBands[nBand].NumLines = 1        && for now
   IF GlobalRpt.SubGroupPtr # NO3PLUSVALUE
      nBand = nBand + 1
      aBands[nBand] = NEW Band()
      aBands[nBand].db3FillBand( btGroupSummary, 2 )
      IF IsTotal
         aBands[nBand].NumLines = 2
         aBands[nBand].CorrBandId = 3
         aBands[3].CorrBandId = nBand
      ENDIF
   ENDIF
   IF GlobalRpt.GroupPtr # NO3PLUSVALUE
      nBand = nBand + 1
      aBands[nBand] = NEW Band()
      aBands[nBand].db3FillBand( btGroupSummary, 1 )
      IF IsTotal
         aBands[nBand].NumLines = 2
      ENDIF
   ENDIF
   IF isTotal
      nBand = nBand + 1
      aBands[nBand] = NEW Band()
      aBands[nBand].db3FillBand( btReportSummary, 0 )
      aBands[nBand].NumLines = 2
   ENDIF
   
   *---------------------------------------------
   *-- Start filling in the fields for the report
   *---------------------------------------------
   nHeadLines = 0
   nItmCnt = 1
   nRow = 0
   IF .NOT. GlobalRpt.PlainPage
      *------------------------------------------
      *-- Create the Page number and date heading
      *------------------------------------------
      aFields[nItmCnt, 01] = db3frmPageStr
      aFields[nItmCnt, 02] = 9     && text value
      aFields[nItmCnt, 14] = 1
      aFields[nItmCnt, 15] = nRow
      aFields[nItmCnt, 16] = 0
      aFields[nItmCnt, 17] = LEN( db3frmPageStr )
      aFields[nItmCnt, 4] = aFields[nItmCnt, 17]
            
      nItmCnt = nItmCnt + 1
      aFields[nItmCnt, 01] = frmPageNo
      aFields[nItmCnt, 02] = 3     && predefined
      aFields[nItmCnt, 08] = 3     && PageNo
      aFields[nItmCnt, 14] = 1
      aFields[nItmCnt, 15] = nRow
      aFields[nItmCnt, 16] = LEN( db3frmPageStr ) + 2
      aFields[nItmCnt, 17] = 5
      aFields[nItmCnt, 4] = aFields[nItmCnt, 17]
   
      nItmCnt = nItmCnt + 1
      nRow = nRow + 1
      aFields[nItmCnt, 01] = frmDate
      aFields[nItmCnt, 02] = 3     && predefined
      aFields[nItmCnt, 08] = 0     && Date
      aFields[nItmCnt, 14] = 1
      aFields[nItmCnt, 15] = nRow
      aFields[nItmCnt, 16] = 0
      aFields[nItmCnt, 17] = 8
      aFields[nItmCnt, 4] = aFields[nItmCnt, 17]
      
      nHeadLines = 3
      nRow = nRow + 1
      nItmCnt = nItmCnt + 1
      
   ENDIF
   
   nRow = nRow + 1         && skip one line before any title
   
   *-------------------------------------
   *-- Create the page title if available
   *-------------------------------------
   nNextRow = nRow
   IF GlobalRpt.TitlePtr # NO3PLUSVALUE
      cTitle = AddrBuck( bucket, GlobalRpt.TitlePtr )
      DO RW3_Head WITH cTitle, nRow, GlobalRpt.LeftMargin, GlobalRpt.Wide, rw3_center, nNextRow, nItmCnt
      nRow = nNextRow + 3
   ENDIF
   
   aBands[1].NumLines = nNextRow + 6       && There are 6 lines in the title
   
   *-------------------------------------------------------
   *-- Add the text and summary fields to the group headers
   *-------------------------------------------------------
   nDetailBand = 2
   nReportSumBand = 3
   nGrpFootBand = 0
   nSubGrpFootBand = 0
   IF GlobalRpt.GroupPtr # NO3PLUSVALUE
      DO AddGroupHeader WITH "**", nItmCnt
      nDetailBand = 3
      nReportSumBand = 5
      nGrpFootBand = 4
   ENDIF
   IF GlobalRpt.SubGroupPtr # NO3PLUSVALUE
      DO AddGroupHeader WITH "*", nItmCnt
      nDetailBand = 4
      nReportSumBand = 7
      nSubGrpFootBand = 5
      nGrpFootBand = 6
   ENDIF
   
   *-----------------------------------------------
   *-- Add group summary labels if there are totals
   *-----------------------------------------------
   IF isTotal
      *----------------------
      *-- Report summary band
      *----------------------
      aFields[nItmCnt, 01] = db3frmTotal
      aFields[nItmCnt, 02] = 9     && text value
      aFields[nItmCnt, 14] = nReportSumBand
      aFields[nItmCnt, 15] = 0
      aFields[nItmCnt, 16] = GlobalRpt.LeftMargin
      aFields[nItmCnt, 17] = LEN( db3frmTotal )
      aFields[nItmCnt, 4] = aFields[nItmCnt, 17]
      nItmCnt = nItmCnt + 1
      
      *----------------
      *-- SubGroup band
      *----------------
      IF GlobalRpt.SubGroupPtr # NO3PLUSVALUE
         aFields[nItmCnt, 01] = db3frmSubGrpTot
         aFields[nItmCnt, 02] = 9     && text value
         aFields[nItmCnt, 14] = nSubGrpFootBand
         aFields[nItmCnt, 15] = 0
         aFields[nItmCnt, 16] = GlobalRpt.LeftMargin
         aFields[nItmCnt, 17] = LEN( db3frmSubGrpTot )
         aFields[nItmCnt, 4] = aFields[nItmCnt, 17]
         nItmCnt = nItmCnt + 1
      ENDIF
      
      *--------------------
      *-- Group footer band
      *--------------------
      IF GlobalRpt.GroupPtr # NO3PLUSVALUE
         aFields[nItmCnt, 01] = db3frmGrpTot
         aFields[nItmCnt, 02] = 9     && text value
         aFields[nItmCnt, 14] = nGrpFootBand
         aFields[nItmCnt, 15] = 0
         aFields[nItmCnt, 16] = GlobalRpt.LeftMargin
         aFields[nItmCnt, 17] = LEN( db3frmGrpTot )
         aFields[nItmCnt, 4] = aFields[nItmCnt, 17]
         nItmCnt = nItmCnt + 1
      ENDIF
      
   ENDIF
      
   *--------------------------------------------------------------
   *-- For each column in the report add a field to the detail
   *-- band, add its column header, and if the summary flag is set
   *-- then add a summary field to the summary bands.
   *--------------------------------------------------------------
*   nRow = nRow + 1                     && Row to start title at in page header
   nFldPtrCnt = GlobalRpt.MaxPrintFields + 1
   fCol = GlobalRpt.LeftMargin
   FOR nPtr = 2 TO nFldPtrCnt          && Note, 3+ put the 1st field at the 2nd position
   
      oField = SavFlds[ nPtr ]         && Get a cleaner oRef to field
      
      *------------------------------------
      *--  Add the field to the detail band
      *------------------------------------
      expr = AddrBuck( bucket, oField.dtaptr )
      IF ASCAN( aDbf, UPPER( expr ) ) > 0
         aFields[nItmCnt, 01] = expr
         aFields[nItmCnt, 02] = 0       && dbf field
      ELSE
         aFields[nItmCnt, 01] = "RW_CALC_" + LTRIM( STR( nItmCnt ) )
         aFields[nItmCnt, 02] = 1       && calc field
         aFields[nItmCnt, 12] = expr
      ENDIF
      aFields[nItmCnt, 04] = oField.Width
      aFields[nItmCnt, 14] = nDetailBand
      aFields[nItmCnt, 15] = 0
      aFields[nItmCnt, 16] = fCol
      aFields[nItmCnt, 17] = aFields[nItmCnt, 04]
      nFldIndex = nItmCnt
      
      nItmCnt = nItmCnt + 1
      
      *-------------------------------------------------
      *-- Add the column heading to the page header band
      *-------------------------------------------------
      IF TYPE( expr ) $ "N,F"
         justHow = rw3_right
      ELSE
         justHow = rw3_left
      ENDIF
      IF oField.hdrptr # NO3PLUSVALUE
         cTitle = AddrBuck( bucket, oField.hdrptr )
         nNextRow = nRow
         DO RW3_Head WITH cTitle, nRow, fCol, oField.Width, justHow, nNextRow, nItmCnt
      ENDIF
      
      *-------------------------------------
      *-- Add summary field to summary bands
      *-------------------------------------
      IF oField.TotFlg = "Y"
         
         *-----------------------------
         *-- Add to report summary band
         *-----------------------------
         aFields[nItmCnt, 01] = "RW_CALC_" + LTRIM( STR( nItmCnt ) )
         aFields[nItmCnt, 02] = 2                        && Summary field type
         aFields[nItmCnt, 04] = oField.Width
         aFields[nItmCnt, 05] = aFields[nFldIndex,01]    && Set field to summarize on
         aFields[nItmCnt, 06] = 4                        && Sum operation
         aFields[nItmCnt, 14] = nReportSumBand
         aFields[nItmCnt, 15] = 1
         aFields[nItmCnt, 16] = fCol
         aFields[nItmCnt, 17] = aFields[nItmCnt, 04]
         nItmCnt = nItmCnt + 1
         
         *---------------------
         *-- Add subgroup total
         *---------------------
         IF GlobalRpt.SubGroupPtr # NO3PLUSVALUE
            aFields[nItmCnt, 01] = "RW_CALC_" + LTRIM( STR( nItmCnt ) )
            aFields[nItmCnt, 02] = 2                        && Summary field type
            aFields[nItmCnt, 04] = oField.Width
            aFields[nItmCnt, 05] = aFields[nFldIndex,01]    && Set field to summarize on
            aFields[nItmCnt, 06] = 4                        && Sum operation
            aFields[nItmCnt, 14] = nSubGrpFootBand
            aFields[nItmCnt, 15] = 1
            aFields[nItmCnt, 16] = fCol
            aFields[nItmCnt, 17] = aFields[nItmCnt, 04]
            nItmCnt = nItmCnt + 1
         ENDIF
         
         *------------------
         *-- Add group total
         *------------------
         IF GlobalRpt.GroupPtr # NO3PLUSVALUE
            aFields[nItmCnt, 01] = "RW_CALC_" + LTRIM( STR( nItmCnt ) )
            aFields[nItmCnt, 02] = 2                        && Summary field type
            aFields[nItmCnt, 04] = oField.Width
            aFields[nItmCnt, 05] = aFields[nFldIndex,01]    && Set field to summarize on
            aFields[nItmCnt, 06] = 4                        && Sum operation
            aFields[nItmCnt, 14] = nGrpFootBand
            aFields[nItmCnt, 15] = 1
            aFields[nItmCnt, 16] = fCol
            aFields[nItmCnt, 17] = aFields[nItmCnt, 04]
            nItmCnt = nItmCnt + 1
         ENDIF
         
      ENDIF
      
      fCol = fCol + oField.Width + oField.Space
      
   ENDFOR
   
   ObjHead.nNumFields = nItmCnt - 1
         
   fDispGen.txtReadPcntDone.text    = "100%"      && make the read pcnt done object visible
   
   CLOSE DATABASE
   
   if dump
      ?
      ? "Dump of what is going to CRW"
      ? "============================"
      ?
      ? "* aFields ****************************"
      FOR n = 1 TO ObjHead.nNumFields
         ? "Fld:    ", aFields[n, 01]
         ? "Typ:    ", aFields[n, 02]
         ? "DatTyp: ", aFields[n, 03]
         ? "FldWid: ", aFields[n, 04]
         ? "Sum Fld:", aFields[n, 05]
         ? "Sum Op: ", aFields[n, 06]
         ? "HSR:    ", aFields[n, 07]
         ? ":       ", aFields[n, 08]
         ? ":       ", aFields[n, 09]
         ? ":       ", aFields[n, 10]
         ? ":       ", aFields[n, 11]
         ? "Formula:", aFields[n, 12]
         ? "Hdl:    ", aFields[n, 13]
         ? "Bnd:    ", aFields[n, 14]
         ? "Row:    ", aFields[n, 15]
         ? "Col:    ", aFields[n, 16]
         ? "Wid:    ", aFields[n, 17]
         ? "---------------------------------------"
      NEXT
      
   endif
   
RETURN
*-- EOP: dB3FrmFill

FUNCTION AddrBuck( buck, ptr )
RETURN  substr( buck, BuckOff[ ptr+1 ]+1, BuckLen[ ptr+1 ]-1 )


PROCEDURE AddGroupHeader( cLevel, itmCnt )
   IF cLevel = "**"
      cTitle = cLevel
      IF GlobalRpt.GroupDataPtr # NO3PLUSVALUE
         cTitle = cTitle + " " + AddrBuck( bucket, GlobalRpt.GroupDataPtr )
      ENDIF
      nHeadBand = 2
   ELSE
      cTitle = cLevel
      IF GlobalRpt.SubGroupDataPtr # NO3PLUSVALUE
         cTitle = cTitle + " " + AddrBuck( bucket, GlobalRpt.SubGroupDataPtr )
      ENDIF
      nHeadBand = 3
   ENDIF
   
   oBand = aBands[ nHeadBand ]      && Simplify the object reference to band
         
   aFields[ItmCnt, 01] = cTitle
   aFields[ItmCnt, 02] = 9          && text value
   aFields[ItmCnt, 14] = nHeadBand
   aFields[ItmCnt, 15] = 1
   aFields[ItmCnt, 16] = GlobalRpt.LeftMargin
   aFields[ItmCnt, 17] = LEN( cTitle )
   aFields[ItmCnt, 4] = aFields[ItmCnt, 17]
   itmCnt = itmCnt + 1
   
   nCol = GlobalRpt.LeftMargin + LEN( cTitle ) + 1         && skip one space for the group field
   
   IF oBand.GroupType = "0"         && group on field
      aFields[ItmCnt, 01] = oBand.GroupField
      aFields[ItmCnt, 02] = 0       && dbf field
      nFld = ASCAN( aDbf, UPPER( oBand.GroupField ) )
      *-----------------------------------------------
      *-- Work around bug in FLENGTH() for date fields
      *-----------------------------------------------
      DO CASE
         CASE TYPE( oBand.GroupField ) = "D"
            aFields[ItmCnt, 04] = 8
         OTHERWISE
            aFields[ItmCnt, 04] = FLENGTH( nFld )
      ENDCASE
   ELSE
      aFields[ItmCnt, 01] = "RW_CALC_" + LTRIM( STR( itmCnt ) )
      aFields[ItmCnt, 02] = 1       && calc field
      DO CASE
         CASE oBand.GroupType = "C"
            aFields[ItmCnt, 04] = 25
         CASE oBand.GroupType $ "N,F"
            aFields[ItmCnt, 04] = 10
         CASE oBand.GroupType $ "L"
            aFields[ItmCnt, 04] = 3
         CASE oBand.GroupType $ "D"
            aFields[ItmCnt, 04] = 8
         OTHERWISE
            aFields[ItmCnt, 04] = 10
      ENDCASE
      aFields[ItmCnt, 12] = oBand.GroupExp
   ENDIF
   aFields[ItmCnt, 14] = nHeadBand
   aFields[ItmCnt, 15] = 1
   aFields[ItmCnt, 16] = nCol
   aFields[ItmCnt, 17] = aFields[ItmCnt, 04]
   itmCnt = itmCnt + 1
   
RETURN
*-- EOP: AddGroupHeader( cLevel )

PROCEDURE RW3_head(text, row, col, width, justify, lastrow, nField )
   curLine = text
   nxtLine = ""
   curRow = row
   startCol = 0
   nSemi = 0
   
   DO WHILE LEN(curLine) > 0
      nSemi = AT( ";", curLine )
      IF nSemi > 0
         nxtLine = SUBSTR( curLine, nSemi+1 )
         curLine = LEFT( curLine, nSemi-1 )
      ELSE
         nxtLine = ""
      ENDIF
      IF LEN( curLine ) > 0
         DO CASE
            CASE justify = rw3_left
               startCol = col
            CASE justify = rw3_center
               startCol = col + (width - len(curLine)) / 2
            CASE justify = rw3_right
               startCol = col + width - len(curLine)
         ENDCASE
         *--------------------------
         *-- Add the text to aFields
         *--------------------------
         aFields[nField, 01] = curLine
         aFields[nField, 02] = 9            && text value
         aFields[nField, 14] = 1            && Page heading band
         aFields[nField, 15] = curRow
         aFields[nField, 16] = startCol
         aFields[nField, 17] = LEN( curLine )
         aFields[nField, 04] = aFields[nField, 17]
         nField = nField + 1
      ENDIF
      curRow = curRow + 1
      curLine = nxtLine
   ENDDO
   
   lastrow = MAX( lastrow, curRow - 1 )
      
RETURN
*-- EOP: RW3_Heading

PROCEDURE FillArrays
*-----------------------------------------------------------------------------   
*  DESCRIPTION
*     Read in the rest of the source file and close it when complete.  The
*     result is two arrays aFields and aBands that contain the information
*     for CRW.
*-----------------------------------------------------------------------------   
       
      *-----------------------------------------------------------------------------
      *-- Define the array that holds the field values based on the number of fields
      *-----------------------------------------------------------------------------
      AFieldSize = MAX( ObjHead.nNumFields * 2, 255 ) 
      public array aFields[AFieldSize, 17]

      *-----------------------------------------------------------------------
      *-- Define the array of band objects based on the number of report bands
      *-----------------------------------------------------------------------
      PUBLIC ARRAY aBands[ ObjHead.nNumBands ]

      fDispGen.txtGenrPcntDone.text    = "20%"      && update the status display form
      fDispGen.txtReadPcntDone.Visible = True       && make the read pcnt done object visible
      fDispGen.txtReadPcntDone.text = "20%"      && make the read pcnt done object visible
      nBand = 1

      lIntro = .F.
      nIntroLines = 0
      DO WHILE nBand <= ObjHead.nNumBands
         
         aBands[ nBand ] = new Band()

         fseek(nHandle, 12, 1)                   && Skip 12 bytes (reserved)
         aBands[ nBand ].BandType   = asc(fread(nHandle, 1))
         aBands[ nBand ].GroupNum   = asc(fread(nHandle, 1))         
         aBands[ nBand ].BandEditor = asc(fread(nHandle, 1))

         fseek(nHandle, 8, 1)                    && Skip 8 bytes (reserved).
         
         aBands[ nBand ].Open       = iif(asc(fread(nHandle, 1)) = 1, .t., .f.)
         aBands[ nBand ].GroupType  = asc(fread(nHandle, 1))     && 0 = field, 3 = records, otherwise...

         fseek(nHandle, 4, 1)                    && Skip 4 bytes ("spare").
         
         aBands[ nBand ].GroupRecs  = word2num(fread(nHandle, 2))
         
         fseek(nHandle, 4, 1)                    && Skip 4 bytes (reserved)
         
         aBands[ nBand ].PrintIntro = asc(fread(nHandle, 1))
         aBands[ nBand ].NewPage    = asc(fread(nHandle, 1))
         aBands[ nBand ].TextPitch  = asc(fread(nHandle, 1))
         aBands[ nBand ].Quality    = asc(fread(nHandle, 1))

         aBands[ nBand ].NumLines   = word2num(fread(nHandle, 2))
         
         aBands[ nBand ].Spacing    = asc(fread(nHandle, 1))
         IF aBands[ nBand ].Spacing = 0         && If line spacing is default, set it to
            aBands[ nBand ].Spacing = 1         && single line spacing.
         ENDIF
         
         
         aBands[ nBand ].BandSize   = word2num(fread(nHandle, 2)) && get band size

         aBands[ nBand ].GroupField = readstring(nHandle)         && Field to group on
         aBands[ nBand ].GroupExp   = readstring(nHandle)         && Expr to group on
         
         *------------------------------------------------------------
         *-- Adjust the group type and number to the CRW section value
         *------------------------------------------------------------
         aBands[ nBand ].SetSection()

         IF aBands[ nBand ].BandType = 1 .AND. aBands[ nBand ].Open       && Report intro found and open
            lIntro = .T.
            nIntroLines = aBands[ nBand ].NumLines
         ENDIF
         
         if dump
            aBands[ nBand ].Print()
            ? "****************************"
         endif

         nBand = nBand + 1

      ENDDO
      
      IF lIntro
         nAns = MSGBOX( msgIncludeIntro, ;
                        msgIncludeTitle, ;
                        4 + 32 )
         IF nAns # 6             && Yes not selected
            lIntro = .F.         && Don't include the report intro fields in the page header
         ENDIF
         
      ENDIF
      

      fDispGen.txtGenrPcntDone.text    = "30%"   && update the status display form
      fDispGen.txtReadPcntDone.text    = "30%"      && make the read pcnt done object visible
      nField = 1
      DO WHILE nField <= ObjHead.nNumFields

         fseek(nHandle, 5, 1)                    && skip 5 bytes...
         cFieldName = xtrim(fread(nHandle, 11))
         nFieldType = asc(fread(nHandle, 1))
         cDataType  = fread(nHandle, 1)
         fseek(nHandle, 12 ,1)
         nFldWidth = asc(fread(nHandle, 1))
         supprepeat = iif(asc(fread(nHandle, 1)) = 1, "T", "F")
         ishidden   = iif(asc(fread(nHandle, 1)) = 1, "T", "F")

         if dump
            ? "Field data: ", cFieldName, nFieldType, cDataType, nFldWidth, iif(ishidden = "T", "Hidden", "Visible" )
         endif

         cSummField = ""
         nSummOp = 0
         nResetWhen = " "
         nPreDefTyp = 0
         cDbfName = ""
         IF nFieldType = 2                       && summary...
            cSummField = xtrim(fread(nHandle, 11))
            fseek(nHandle, 4, 1)                 && Reserved.
            nSummOp = asc(fread(nHandle, 1))
            nResetWhen = STR(asc(fread(nHandle, 1)), 1 )
            fseek(nHandle, 73, 1)
            if dump
               ? "Summary data:", cSummField, nSummOp, nResetWhen
            endif
         else
            nPreDefTyp = asc(fread(nHandle, 1))
            cDbfName = chr(nPreDefTyp) + xtrim(fread(nHandle, 80))
            fseek(nHandle, 9, 1)                 &&
            if dump
               ? "DBF Data:", nPreDefTyp, cDbfName
            endif
         ENDIF

         fseek(nHandle, 4, 1)                    &&

         cFieldPict = readstring(nHandle)
         cFieldFunc = readstring(nHandle)
         if dump
            ? "Picture, function:", cFieldPict, cFieldFunc
         endif
         cExpr = ""
         cDesc = ""
         nBandId = 0

         DO CASE
         CASE nFieldType =0 .OR. nFieldType = 4  && dbf or memvar

         CASE nFieldType = 1                     && calc type
            readstring(nHandle)
            cExpr = readstring(nHandle)

         CASE nFieldType = 2                     && summary type
            cDesc   = readstring(nHandle)        && get description
            nBandId = word2num(fread(nHandle, 2))
            fseek(nHandle, 2, 1)                 && Toss hibyte/bandID.

         CASE nFieldType = 3                     && predef type (page numbers, etc...)
            * do nothing...

         ENDCASE
         
         if dump
            ? cFieldPict, cFieldFunc
         endif

         aFields[nField, 01] = cFieldName
         aFields[nField, 02] = nFieldType
         aFields[nField, 03] = cDataType
         aFields[nField, 04] = nFldWidth
         aFields[nField, 05] = cSummField
         aFields[nField, 06] = nSummOp
         aFields[nField, 07] = ishidden + supprepeat + nResetWhen
         aFields[nField, 08] = nPreDefTyp
         aFields[nField, 09] = cDbfName
         aFields[nField, 10] = cFieldPict
         aFields[nField, 11] = cFieldFunc
         aFields[nField, 12] = cExpr
         aFields[nField, 13] = 0             && Field handle after being placed

         nField = nField + 1

      ENDDO

      nItmCnt = ObjHead.nNumFields + 1
      nItmCnt = IncItmCnt( ObjHead.nNumFields + 1 )

      fDispGen.txtReadPcntDone.text = "40%"      && make the read pcnt done object visible
      fDispGen.txtGenrPcntDone.text    = "40%"   && update the status display form
      fseek(nHandle, 68, 1)                      && Skip global ruler
      if dump
         ? "Starting band...", fseek(nHandle, 0, 1)
      endif
      nBand = 1
      DO WHILE nBand <= ObjHead.nNumBands
         if aBands[nBand].BandEditor = 1 && if wordwrap band
            do dump_ww with nBand
         else
            do dumplayout with nBand, ObjHead.nNumFields
         endif
         nBand = nBand + 1
      ENDDO

      ObjHead.nNumFields = nItmCnt - 1
      fDispGen.txtGenrPcntDone.text    = "75%"   && update the status display form

      if dump
         ?
         ? "Dump of what is going to CRW"
         ? "============================"
         ?
         ? "* aFields ****************************"
         FOR n = 1 TO ObjHead.nNumFields
            ? "Fld:    ", aFields[n, 01]
            ? "Typ:    ", aFields[n, 02]
            ? "DatTyp: ", aFields[n, 03]
            ? "FldWid: ", aFields[n, 04]
            ? "Sum Fld:", aFields[n, 05]
            ? "Sum Op: ", aFields[n, 06]
            ? "HSR:    ", aFields[n, 07]
            ? ":       ", aFields[n, 08]
            ? ":       ", aFields[n, 09]
            ? ":       ", aFields[n, 10]
            ? ":       ", aFields[n, 11]
            ? "Formula:", aFields[n, 12]
            ? "Hdl:    ", aFields[n, 13]
            ? "Bnd:    ", aFields[n, 14]
            ? "Row:    ", aFields[n, 15]
            ? "Col:    ", aFields[n, 16]
            ? "Wid:    ", aFields[n, 17]
            ? "---------------------------------------"
         NEXT
         
      endif
      
      fclose(nHandle)

RETURN
*-- EOP: FillArrays

FUNCTION IncItmCnt( nValue )
*----------------------------------------------------------------------------
*  DESCRIPTION
*     IncItmCnt() returns next array row to use for aFields[]) to nValue.  
*     If nValue exceeds AFieldSize (the number of rows in aFields[] ), then
*     add 20 rows to AFields[]
*
*  EXTERNAL VARAIBLES
*     AFieldSize, aFields[]
*----------------------------------------------------------------------------
   IF nValue >= AFieldSize
      IF dump
         ? lineno(), program(), "Adding 20 rows to AFields[], nItmCnt =", nItmCnt
      ENDIF
      
      AFieldSize = AFieldSize + 20
      ARESIZE( aFields, aFieldSize, 17, 1 )
      
      IF TYPE("dump") = "L" .AND. dump
         ? "    AFields[] rows =", ALEN( aFields, 1 ), "AFieldSize =", AFieldSize
         ? "Field name, Band, row, col"
         FOR i = 1 TO aFieldSize
            ? "AField[",ltrim(str(i)),"]=", aFields[i,1], aFields[i,14], aFields[i,15], aFields[i,16]
         NEXT
         
*         WAIT
         IF LASTKEY() = 27
            CLOSE ALL
            CLEAR ALL
            QUIT
         ENDIF
         
      ENDIF
      
   ENDIF
   
RETURN nValue
    

FUNCTION IsSumDbf( nId, nFlds )
*----------------------------------------------------------------------------
*  DESCRIPTION
*     This function returns .T. if the summary field is based on a DBF field.
*     It scans the aFields[] array looking for the field to summary on (5).
*----------------------------------------------------------------------------
   PRIVATE lIsDbf, cSumFldname, i
   
   lIsDbf = .F.
   cSumFldName = aFields[ nId, 5 ]
   FOR i = 1 TO nFlds
      IF aFields[ i, 1 ] = cSumFldName    && Does the field name = field to sum on
         IF aFields[ i, 2 ] = 0           && Does the field type = dbf field
            lIsDbf = .T.
            EXIT
         ENDIF
      ENDIF
   NEXT
RETURN lIsDbf

FUNCTION getSumType(nSumOp)
   DO CASE
   CASE nSumOp = 4
      nCrwSumOp = 0                              && sum...
   CASE nSumOp = 0
      nCrwSumOp = 1                              && avg...
   CASE nSumOp = 1
      nCrwSumOp = 6                              && cnt...
   CASE nSumOp = 2
      nCrwSumOp = 4                              && max...
   CASE nSumOp = 3
      nCrwSumOp = 5                              && min...
   CASE nSumOp = 5
      nCrwSumOp = 8                              && sdv...
   OTHERWISE
      nCrwSumOp = 0                              && sum...
   ENDCASE
RETURN (nCrwSumOp)

FUNCTION getSection( nBand )
*----------------------------------------------------------------------------
*  DESCRIPTION
*     This function returns the CRW section value from the aBands[] object
*     array.
*----------------------------------------------------------------------------
   
RETURN ( aBands[ nBand ].CRWSection )

PROCEDURE dump_ww(bandNum)
*----------------------------------------------------------------------------
*  DESCRIPTION
*     This routine takes the lines in the word wrap band and creates
*     character expression formulas that are inserted into Crystal.
*
*
*  FORMAT
*     A word wrap band consists of a series of paragraphs.  Each paragraph
*     contains lines of text combined with fields and style attributes and
*     terminates with a ruler.  Field and style attributes are surrounded
*     by a start token (01h) and an end token (02h).  
*  
*     The field attribute consists of a field mark value (A0h) followed 
*     by 8 ASCII characters that represent the field id in hex.  For 
*     example: "0A000000" is field 10, "0C010000" is field 268.
*  
*     The style attributes consists of two bytes that are ignored for now
*     because Crystal doesn't allow embedded styles within a formula.
*  
*     An editor line terminates with any of the following:
*        00h 02h - Hard end of line, ruler start
*        8Dh 0Ah - Soft return, line feed (wrap within the band)
*  
*     The ruler consists of sets of three ASCII characters that make up
*     a decimal value for its components as follows:
*  
*        CHAR  3  Left margin    (ex "  0" for 0)
*        CHAR  3  Rigth margin   (ex "254" for 254)
*        CHAR  3  Indent         (ex "  0" for 0)  The indent is relative
*                                to the left margin and may be negative.
*                                (ex "  +" for -5, take 2Bh(+) - 30h(0) to
*                                get -5)
*        CHAR  3  Tab stop 1     (ex "  8" for 8)
*        CHAR  3  ....
*        CHAR  3  Up to tab 30   (ex "240" for 240)
*  
*        If there are less than 30 tabs, a "/" character is placed in the 
*        third position for the remaining tab stops.  For example, "  /".
*  
*     Tabs within the ruler are ignored during the conversion.  The left and
*     right margins are used to determine the placement and width of the 
*     formula.
*  
*     The ruler terminates with the following three characters:
*  
*        00h 0Dh 0Ah
*  
*     Idealy, we would create an expression that combines all the lines
*     in a paragraph into a single formula.  The formula would then be placed
*     on the surface as a multi-line object.  But, Crystal currently supports 
*     strings up to 255 characters.  So either, a formula is created for
*     lines with fields or a text object for lines without.
*  
*----------------------------------------------------------------------------
    
   if dump
      ? "In dump_ww(", bandNum, ")"
   endif
  
   BandSize = word2num(fread(nHandle, 2))
   if dump
      ? "BandSize = ", BandSize
   endif

   private wholeband
   wholeband = fread(nHandle, bandsize)
   private marker, nFieldNum
   marker = 1
   private paragraph, linetext, lineno, linemark, fieldmark, column, fieldwidth
   private lmargin, lindent
   private lineform
   lineno = -1
   if dump
       ? "Scanning the wordwrap band.."
       ? "============================"
   endif

   do while marker < bandsize
         lineno = lineno + 1
         lineform = ""
         if dump
            ? "Lineno = ", lineno
         endif
         paragraph = substr(wholeband, marker)
         paragraph = left(paragraph, at(chr(0), paragraph) - 1)
         if dump
            ? "Paragraph = ", paragraph
         endif
         *---------------------------------------------------
         *-- Set marker to the next paragraph after the ruler
         *---------------------------------------------------
         marker = marker + len(paragraph) + 104
         
         lmargin = val(substr(wholeband,marker - 102,3))
         rmargin = val(substr(wholeband,marker - 99,3))
         lindent = val(substr(wholeband,marker - 96,3))
         if dump
            ? "LMargin = ", lMargin
            ? "RMargin = ", rMargin
            ? "LIndent = ", lIndent
         endif
         
         *--------------------------------------------------
         *-- Check for an out indent that would start with -
         *--------------------------------------------------
         if lindent = 0 .and. substr(wholeband,marker - 95,2) <> " 0"
               if substr(wholeband, marker - 95,1) <> " "
                     lindent = (48-asc(substr(wholeband,marker - 95,1))) * 10
               endif
               lindent = lindent + 48 - asc(substr(wholeband,marker - 94,1))
               lindent = 0 - lindent
               if dump
                  ? "  Modified LIndent = ", lIndent
               endif
         endif
         column = lmargin + lindent
         if dump
            ? "Column = ", column
         endif

         *---------------------------------------------------
         *-- Pick out the elements that make up the paragraph
         *---------------------------------------------------
         expPara = ""
         isFirstLine = .T.
         do while len(paragraph) > 0
               linemark = at(chr(141)+chr(10), paragraph)   	&& Multiline para
               fieldmark = at(chr(1), paragraph)		&& Field found
              
               do case
               *----------------------------------------------------------------
               *-- If this is a multiline paragraph and the field mark is on the
               *-- next line or not present:
               *----------------------------------------------------------------
               case linemark > 0 .and. (linemark < fieldmark .or. fieldmark = 0)
                     if dump
                        ? lineno(), "Soft Cr found with no fields"
                     endif               
                     
                     *-----------------------------------------------------------
                     *-- Set linetext to the value of the line up to the linemark
                     *-----------------------------------------------------------
                     linetext = left(paragraph, linemark - 1)
                     lineform = addtoform( lineform, linetext )
                                          
                     *-----------------------------------------------------------
                     *-- Set paragraph to the remaining amount after the linemark
                     *-----------------------------------------------------------
                     paragraph = substr(paragraph, len(linetext) + 3)
                     if dump
                        ? lineno(), "linetext = ", linetext
                        ? lineno(), "remain para = ", paragraph
                     endif
                     
               *-----------------------------------------------------------------
               *-- If a field is present and it's before the soft linemark or the
               *-- the linemark is not around:
               *-----------------------------------------------------------------
               case fieldmark > 0 .and. (fieldmark < linemark .or. linemark = 0)
                     
                     if dump
                        ? lineno(), "Token found before soft cr or no cr"
                     endif
                     
                     *----------------------------------------------------------
                     *-- Set linetext to any text that might be before the field
                     *----------------------------------------------------------
                     linetext = left(paragraph, fieldmark - 1)
                     if dump
                        ? lineno(), "Text before fieldmark =", linetext
                     endif
                     lineform = addtoform( lineform, linetext )
                     
                     *------------------------------------------------
                     *-- Determine the type of token by looking at the
                     *-- next character after tok_start.
                     *------------------------------------------------
                     tokenType = substr( paragraph, fieldmark + 1, 1 )

                     *--------------------------------------------------
                     *-- Get the bytes between the tok_begin and tok_end
                     *-- nAfterTok is the position in the paragraph just
                     *-- after the tok_end.
                     *--------------------------------------------------
                     tokString = ""
                     nAfterTok = TokValue( tokString, paragraph, fieldmark+1 )
                     if dump
                        ? "Token bytes:", nAfterTok
                        ? "Token type:", tokenType
                        ? "tokString:", tokString
                     endif

                     DO CASE
                        CASE tokenType = ATT_FIELD 
                           
                           *------------------------
                           *-- A field pointer value
                           *------------------------
                           if dump
                              ? lineno(), "Enter HexStr2Bin()"
                           endif
                           nFieldNum = HexStr2Bin( tokString )
                           if dump
                              ? lineno(), "Returned from HexStr2Bin"
                              ? lineno(), "Field token = ", nFieldNum
                           endif
                           lineform = addtoform( lineform, nFieldNum )

                        OTHERWISE
                           *-------------------------------------------
                           *-- This is a style, which has to be ignored
                           *-------------------------------------------
                           if dump
                              ? lineno(), "Style token - ignored"
                           endif
                     ENDCASE

                     IF TYPE( "aFields[nFieldNum, 4]" ) = "N"
                        fieldwidth = aFields[nFieldNum, 4]
                     ELSE
                        fieldwidth = 0
                     ENDIF
                     
                     *-- Set the paragraph
                     if dump
                        ? lineno(), "Get more paragraph!"
                     endif
                     if len(paragraph) > len(linetext) + 12
                        if dump
                           ? lineno(), "More para exists!"
                        endif
                        paragraph = substr(paragraph, len(linetext) + 12)
                     else
                        if dump
                           ? lineno(), "no more para."
                        endif
                        paragraph = ""
                     endif
                     if dump
                        ? lineno(), "Remaining para:", paragraph
                     endif
                     
               otherwise
                     linetext = paragraph
                     paragraph = ""
                     if dump
                        ? lineno(), "Otherwise, para is a single line remaining."
                        ? "linetext = ", linetext
                     endif
                     lineform = addtoform( lineform, linetext )

               endcase
               
               if dump
                  ? lineno(), "What is linetext now:", linetext
               endif

               if linemark > 0 .and. (linemark < fieldmark .or. fieldmark = 0)
                     if dump
                        ? "Line expression:", lineform
                     endif
                     
                     *-- Add expression to field array
                     aFields[nItmCnt, 01] = "WW_CALC_" + LTRIM( STR( nItmCnt) )
                     aFields[nItmCnt, 02] = 1                  && Calc field
                     aFields[nItmCnt, 03] = "C"                && data type
                     aFields[nItmCnt, 04] = rMargin - lMargin  && field width
                     aFields[nItmCnt, 12] = lineForm           && line expression
                     aFields[nItmCnt, 14] = nBand
                     aFields[nItmCnt, 15] = lineno
                     IF isFirstLine
                        aFields[nItmCnt, 16] = lMargin + LIndent  && column position
                        aFields[nItmCnt, 04] = rMargin - lMargin - LIndent && field width
                        isFirstLine = .F.
                     ELSE
                        aFields[nItmCnt, 16] = lMargin            && column position
                     ENDIF
                     nItmCnt = IncItmCnt( nItmCnt + 1 )
                     
                     lineno = lineno + 1
                     lineform = ""
                     if dump
                        ? lineno(), "Lines in band now is:", lineno
                     endif
               endif
               if fieldmark > 0 .and. (fieldmark < linemark .or. linemark = 0)
                     column = column + len(linetext) + fieldwidth
               else
                     column = lmargin
               endif
               if dump
                  ? lineno(), "Column now at:", column
               endif   
         enddo    && processing paragraph

         IF .NOT. ISBLANK( lineform )
            if dump
               ? "Line expression:", lineform
            endif
            
            *-- Add expression to field array
            aFields[nItmCnt, 01] = "WW_CALC_" + LTRIM( STR( nItmCnt) )
            aFields[nItmCnt, 02] = 1                  && Calc field
            aFields[nItmCnt, 03] = "C"                && data type
            aFields[nItmCnt, 04] = rMargin - lMargin  && field width
            aFields[nItmCnt, 12] = lineForm           && line expression
            aFields[nItmCnt, 14] = nBand
            aFields[nItmCnt, 15] = lineno
            aFields[nItmCnt, 16] = lMargin            && column position
            nItmCnt = IncItmCnt( nItmCnt + 1 )
                     
         ENDIF            
         
   enddo    && processing band
   IF dump
      ? "------------------------"
      ? "Word wrap dump complete!"
      ? "------------------------"
   ENDIF   
   
RETURN


PROCEDURE dumpLayout(nBand, nFlds)
*-----------------------------------------------------------------------------
*  DESCRIPTION
*     First establish the row and columns for each of the fields on the form.
*     Then assemble the text row.
*-----------------------------------------------------------------------------

   nBandSize = word2num(fread(nHandle, 2))

   nBandStart = fseek(nHandle, 0, 1)
   nVers = asc(fread(nHandle, 1))
   nBandEnd = nBandStart + nBandSize

   nMaxWidth  = word2num(fread(nHandle, 2))
   nMaxHeight = word2num(fread(nHandle, 2))

   if dump
      ? "Band Info:", nVers, nBandSize, nBandStart, nBandEnd, nMaxWidth, nMaxHeight
   endif
   fread(nHandle, 4)                     && Ignore #rows, #textrows

   DO WHILE fread(nHandle, 1) = ","
      nField = word2num(fread(nHandle, 2)) && get the field number
      if dump
         ? "field # " + str(nField) + " at " + str(fseek(nHandle, 0, 1)-2)
      endif

      if nVers = 4
         fseek(nHandle, 12, 1)
      endif

      if dump
         ? "Band/Field:", nBand,nField
      endif
      aFields[nField, 14] = nBand
      aFields[nField, 15] = word2num(fread(nHandle, 2))  && row
      aFields[nField, 16] = word2num(fread(nHandle, 2))  && col
      aFields[nField, 17] = word2num(fread(nHandle, 2))  && wid

      if dump
         ? lineno(), "Field: ", nField, aFields[nField, 1], ;
           "Row:", aFields[nField, 15], "Col:",aFields[nField, 16], "Wid:", aFields[nField, 17]
      endif
      if nVers = 4
          fseek(nHandle, 4, 1)
      endif
      if asc(fread(nHandle, 1)) <> 0
         *------------------------------------------------------------------
         *-- Ignore the window information - should never happen for reports
         *------------------------------------------------------------------
         if nVers= 4
            fseek(nHandle,8,1)
         endif
         fseek(nHandle,8,1)               && Skip window frame.
         winfo = fread(nHandle,9)
         fseek(nHandle,2,1)               && Toss attribute for now...
         if nVers = 4
            fseek(nHandle,3,1)
         endif
      endif

   ENDDO
   
   *--------------------------------------------------------------------------
   *-- We attempted to read a "." which was the list terminator for the Layout
   *-- fields.  Get any box descriptions as needed and ignore them.
   *--------------------------------------------------------------------------

   &&& get the box stuff...
   private boxdlength
   if nVers = 5
      boxdlength = 19
   else
      boxdlength = 28
   endif
   cBoxDesc = fread(nHandle,boxdlength)
   do while left(cBoxDesc, 1) = ","
      if nVers = 4
        cBoxDesc = substr(cBoxDesc,9)
      endif
      nHBoxPos = word2num(substr(cBoxDesc, 10, 2))
      nVBoxPos = word2num(substr(cBoxDesc, 12, 2))
      nBWidth  = word2num(substr(cBoxDesc, 14, 2))
      nBHeight = word2num(substr(cBoxDesc, 16, 2))
      nVBoxPos = nVBoxPos + nBandStart

      if dump
         ? "Box Desc:", cBoxDesc, nBWidth
      endif
      cBoxDesc = fread(nHandle, boxdlength)

   enddo

   fseek(nHandle,1 - boxdlength,1)        && Rewind, we read an extra box descriptor above.

   IF dump
      ?
      ?  "*-- Process the Text Rows for band:", nBand
   ENDIF
   *---------------------------------------------------------------------------------
   *-- Text Rows
   *-- ---------
   *-- Starting        Data    Length          Contents/Purpose
   *-- Byte            Type    in Bytes
   *-- 
   *-- 0               INT16      2            Offset from previous row
   *-- 
   *-- 2               INT16      2            Size in bytes of row
   *-- 
   *-- 4               CHAR                    Packed row
   *-- 
   *-- 
   *-- 
   *-- A packed row is a sequence of type code/value pairs.  The type code is
   *-- a single byte.  The type code determines the interpretation of succeeding
   *-- bytes.
   *-- 
   *-- Type              Code     Value Data   Length     Value
   *--                               Type      in Bytes
   *-- End of row         0       none
   *-- Skip columns       1       BYTE            1       Number of columns to skip
   *-- Field              2       UINT32          4       Field pointer
   *-- Text               3       CHAR                    Zero terminated string
   *-- Style attribute    4       UINT16          2       New style attribute
   *-- Display attribute  5       UINT16          2       New display attribute
   *-- Page break         8       none
   *---------------------------------------------------------------------------------
   
   this_row    = 0
   bytesread   = 0
   
   DECLARE FldsInExp[100]
   nFldExpCnt = 0

   cCombineExp = ""
   do while fseek(nHandle, 0, 1) < nBandEnd && While bytes left in this band...
      this_col    = 0
      scanned     = 0
      this_row = this_row + word2num(fread(nHandle, 2))     && Offset from previous row
      size_row = word2num(fread(nHandle, 2))
      if size_row < 1
         loop
      endif
      bytesread = bytesread + size_row
      packed_row = fread(nHandle, size_row)
      *****
      * cbMsge("size_row:" + str(size_row, 10, 2) + "::this_row:" + str(this_row, 10, 2), msgAlert)
      *****
      nItems = 1
      
      IF dump
         ? lineno(), "Scanning text row:", this_row
      ENDIF

      show_row = ""      
      cCombineExp = ""
      nFldExpCnt = 0
      
      do while scanned < size_row - 1
         scanned = scanned + 1
         nValueType= asc(substr(packed_row, scanned,1))
         value = substr(packed_row, scanned + 1)         && Get the remainder of the line after type
         nItems = nItems + 1
         DO CASE
         CASE nValueType = 8               && Page break, who cares?
               if dump
                  show_row = show_row + "<Page Break>"
               endif
               
         CASE nValueType = 4               && Style changes, ignore.
               if dump
                  show_row = show_row + "<Style>"
               endif
             scanned = scanned + 2
         CASE nValueType = 5               && Color changes, ignore.
             scanned = scanned + 2
               if dump
                  show_row = show_row + "<Color>"
               endif
         CASE nValueType = 2               && Found a field.
             *--------------------------------------------------------------------
             *-- This is ugly here.  Need to scan the list of fields looking for
             *-- a field that is in the same band with the same row and column and
             *-- is not hidden.
             *--------------------------------------------------------------------
             scanned = scanned + 4           && Bypass the internal field pointer value
             nFldNum = 1
             lHit = .F.
             DO WHILE nFldNum <= nFlds
               xBand = "aFields[" + str(nFldNum, 3) + ", 14]"
               xRow  = "aFields[" + str(nFldNum, 3) + ", 15]"
               xCol  = "aFields[" + str(nFldNum, 3) + ", 16]"

               IF type(xBand) = "N" .AND. type(xRow) = "N" .AND. type(xCol) = "N"
                  IF aFields[nFldNum, 14] = nBand .AND. aFields[nFldNum, 15] = this_row .AND. aFields[nFldNum, 16] = this_col
                     
                     *------------------------------
                     *-- Check for the Trim function
                     *------------------------------
                     IF TYPE("aFields[nFldNum,11]") = "C" .AND. "T" $ aFields[nFldNum,11]
                        nFldExpCnt = nFldExpCnt + 1                     && Inc. pointer to FldsInExp
                        FldsInExp[ nFldExpCnt ] = nFldNum               && Store field num
                        cCombineExp = AddToForm( cCombineExp, nFldNum ) && Add the expression in
                        IF nFldExpCnt > 1
                           *-------------------------------------------------------------------------
                           *-- Add field length to the first field length for the combined expression
                           *-------------------------------------------------------------------------
                           aFields[ FldsInExp[1], 17 ] = aFields[ FldsInExp[1], 17 ] + aFields[ nFldNum, 17 ]
                        ENDIF
                        
                     ELSE
                        IF "+" $ cCombineExp
                           DO MakeComboFld              
                        ENDIF
                        DO ClearCombo
                     ENDIF
                     
                     if dump
                        show_row = show_row + "<field" + STR( nFldNum,3 ) + ">"
                     endif
                     this_col = this_col + aFields[nFldNum, 17]   && Compute the next column position
                     lHit = .T.
                     exit
                  ENDIF
               ENDIF

               nFldNum = nFldNum + 1
             ENDDO
             IF dump
                IF .NOT. lHit
                   ? "Field at:", this_row, this_col, "not found! AFields[] follows:"
                   ? "Field name, Band, row, col"
                   FOR i = 1 TO nFlds
                     ? "AField[",ltrim(str(i)),"]=", aFields[i,1], aFields[i,14], aFields[i,15], aFields[i,16]
                   NEXT
                   
                ENDIF
                
             ENDIF
             
            
         CASE nValueType = 1               && Skip columns.
            scanned = scanned + 1
            n2Skip = asc( LEFT( value, 1 ) )
            this_col = this_col + n2Skip
            if dump
              show_row = show_row + "<" + LTRIM( STR( n2Skip ) ) + " spaces>"
            endif
            
            IF "+" $ cCombineExp
               DO MakeComboFld              
            ENDIF
            DO ClearCombo
             
         CASE nValueType = 0               && End of row.
             this_col = 0
             if dump
                show_row = show_row + "<END>"
             endif
            IF "+" $ cCombineExp
               DO MakeComboFld              
            ENDIF
            DO ClearCombo
             
         CASE nValueType = 3               && text item...
            textlength = at(chr(0), value)       && Get string len including the 00h
            value = left(value,textlength - 1)   && Store the text string
            scanned = scanned + textlength       && Set the string printer past the text
               
            *-- Before creating the text object, see if the prior item is a combo exp
            IF .NOT. ISBLANK( cCombineExp )
               cCombineExp = AddToForm( cCombineExp, value ) && Add the text to the exp
               aFields[ FldsInExp[1], 17] = aFields[ FldsInExp[1], 17] + textlength - 1
            ELSE
               aFields[nItmCnt, 01] = value
               aFields[nItmCnt, 02] = 9     && text value
               aFields[nItmCnt, 14] = nBand
               aFields[nItmCnt, 15] = this_row
               aFields[nItmCnt, 16] = this_col
               aFields[nItmCnt, 17] = textlength - 1
            
               nItmCnt = IncItmCnt( nItmCnt + 1 )
            ENDIF
            
            if dump
               show_row = show_row + value
            endif
            
            this_col = this_col + textlength - 1 && Set the next column position
         ENDCASE
      enddo
      
      IF dump
         ? "Show_row:", show_row
      ENDIF
      
      IF "+" $ cCombineExp
         DO MakeComboFld              
      ENDIF
      DO ClearCombo
      
   enddo
   
RETURN

PROCEDURE ClearCombo
*-----------------------------------------------------------------------------
*  DESCRIPTION
*     Inline support routine for dumplayout.  Uses the private variables
*     in the routine to clear the combined expression.
*-----------------------------------------------------------------------------
   *------------------------------------------- 
   *-- Reset the combined expression components
   *------------------------------------------- 
   cCombineExp = ""
   nFldExpCnt = 0
RETURN


PROCEDURE MakeComboFld
*-----------------------------------------------------------------------------
*  DESCRIPTION
*     Inline support routine for dumplayout.  Uses the private variables
*     in the routine to create a calculated field for the combined expression.
*-----------------------------------------------------------------------------
   *--------------------------------------------------------
   *-- Need to create function field for the combined fields
   *--------------------------------------------------------
   aFields[nItmCnt, 01] = "RW_CALC_" + LTRIM( STR( nItmCnt ) )
   aFields[nItmCnt, 02] = 1     && calc field
   aFields[nItmCnt, 12] = cCombineExp
   aFields[nItmCnt, 14] = nBand
   aFields[nItmCnt, 15] = aFields[ FldsInExp[1], 15 ]   && Row for the first field in exp
   aFields[nItmCnt, 16] = aFields[ FldsInExp[1], 16 ]   && Column for the first field in exp
   aFields[nItmCnt, 17] = aFields[ FldsInExp[1], 17 ]   && Accumulated widths of combined values
   aFields[nItmCnt, 04] = aFields[ FldsInExp[1], 17 ]   && Other field width needed
   nItmCnt = IncItmCnt( nItmCnt + 1 )
   
   *-----------------------------------------------------------------------------
   *-- Prevent the fields in the expression from printing by clearing the band id
   *-----------------------------------------------------------------------------
   FOR i = 1 TO nFldExpCnt
      aFields[ FldsInExp[i], 14 ] = .F.
      FldsInExp[i] = .F.
   NEXT
RETURN

*-------------------------------------------------
*-- Comon Routines between FRM and LBL conversions
*-------------------------------------------------
PROCEDURE InitFrmLbl
PARAMETERS pcSrcFile, pcCRWFile, pcExt, pcCRWExt, pcCatName, pcViewFile
*-----------------------------------------------------------------------------
*  DESCRIPTION
*     Set initial values for Private memory variables and set up the
*     status display.
*-----------------------------------------------------------------------------
   LOCAL cSrcName, cCRWName, cTitleFile
   
   lVoid    = 0
   nLine   = 0
   nHandle = 0                                   && create the memvar
   cChar   = ""
   cString = ""

   pcViewFile = cbPath() + "cb.vue"              && ge the proper path to the program
   create view &pcViewFile from environment      && save the current environment

   clear typeahead                               && clear the keyboard buffer in case someone has 
                                                 && touched the keyboard while the conversion 
                                                 && process starts up
                                                 
   cSrcName = upper(parsePath((pcSrcFile))) + pcExt
   cCRWName = upper(parsePath((pcCRWFile))) + pcCRWExt

   cTitleFile = IIF(empty(pcCatName), "", upper(pcCatName) + ".CAT::") + cSrcName
   fDispGen = new dispGenForm()
   fDispGen.Text = formatStr( fDispGen.Text, cTitleFile )

   fDispGen.txtSrcLine.visible  = False          && hide references to line numbers in the status window
   fDispGen.txtSrceLine.visible = False
   fDispGen.txtDstLine.visible  = False
   fDispGen.txtDestLine.visible = False

   && set the srce file/dest file names on the status display screen...
   fDispGen.txtSrcFile.text = cSrcName
   fDispGen.txtDstFile.text = cCRWName
   fDispGen.txtMsgeRead.text = msgReading
   fDispGen.txtReadPcntDone.text = "20%"        && show read percent at 80% done...

   *-------------------------------------
   *-- Open the form to display the stats
   *-------------------------------------
   fDispGen.open()
   fDispGen.setFocus()
   
   && get the stats on the incoming report
   replace Project->srceFile with pcSrcFile
   replace Project->srceDate with fdate(pcSrcFile)
   replace Project->srceTime with ftime(pcSrcFile)

   &&& - save the stats on the outgoing report
   IF System->currDire = True
      replace Project->destFile with cCRWName
   else
      replace Project->destFile with pcCRWFile
   ENDIF
   replace Project->destDate  with date()
   replace Project->destTime  with time()
   pcCRWFile = trim(Project->destFile)
   fDispGen.txtGenrPcntDone.text    = "10%"      && update the status display form


RETURN
*-- EOP: InitFrmLbl

&&& *************************************************************************
&&& Label Converter Parser
&&& *************************************************************************
FUNCTION lbl2rpl(cTitle, cFrmFile, cDbfFile, cRplFile, cCatName)

   local  cCBViewFile
   public nHandle
   
   PRIVATE lVoid, nLine, nHandle, cChar, cString, cViewFile
   cViewFile = ""
   
   DO InitFrmLbl WITH cFrmFile, cRplFile, ".LBL", ".RPL", cCatName, cViewFile
   
   dump = .f.
   if dump
      set alternate to dump.txt
      set alternate on
   endif

   PUBLIC ObjHead
   ObjHead = NEW DB4Descriptor( cFrmFile )
   nHandle = ObjHead.ReadDB4Head()

   IF nHandle = 0
      IF file(cViewFile)                      && if a CB view exists...
         delete file &cViewFile               && delete it
      ENDIF
      fclose(nHandle)
      fDispGen.close()
      cbMsge(msgNotFileFormat, msgAlert)
      return(False)
   ENDIF
   
   ObjHead.DumpDB4Head()

   *----------------------------------------------------------
   *-- Create aFields and ABands arrays by reading source file
   *----------------------------------------------------------
   PRIVATE nItmCnt, AFieldSize, lIntro, nIntroLines
   nItmCnt = 0
   AFieldSize = 0
   lIntro = .F.
   nIntroLines = 0
   
   IF ObjHead.cVersion = sDB3PLUS
      DO dB3LblFill WITH cDbfFile
   ELSE
      DO FillArrays
   ENDIF

   fDispGen.txtMsgeReadDone.Visible = True
   fDispGen.txtReadPcntDone.text = "100%"      && make the read pcnt done object visible
   fDispGen.txtGenrPcntDone.Visible = True
   fDispGen.txtGenrPcntDone.text    = "50%"      && update the status display form
   fDispGen.txtMsgeGenr.Visible     = True
   fDispGen.txtMsgeGenr.text        = frmGenReportCode


   IF ObjHead.nNumFields > 0                             && if there are fields to convert...

      IF "QBE" $ upper(cDbfFile)                 && if we're dealin with a QBE
         set view to (cDbfFile)                  && determine the file name
         cDbf = substr(dbf(), 3)
         cDbf = substr(cDbf, 1, at(".", cDbf) - 1)
         IF file(cViewFile)                      && if a CB view exists...
            set view to &cViewFile               && restore the CB view environment
         ENDIF
      ENDIF

      select 40
      lOpenCrw = peOpenEngine()                  && open the CRW engine
      IF dump
         ? lineno(), "peOpenEngine() =", lOpenCrw
      ENDIF
      
      
      cTemp = MatchLabel()
      IF dump
         ? lineno(), "Label =", cTemp, "cDbfFile=", cDbfFile
      ENDIF
      
      cPointer = makeint(42) + cTemp
      

      nCrwHndl = peNewPrintJob(ansi(cDbfFile), 2, ansi(cPointer))  && engage a print job
      IF dump
         ? lineno(), "peNewPrintJob(ansi(cDbfFile), 2, ansi(cPointer)) =", nCrwHndl
      ENDIF

      nField   = 1
      nFldHndl = 1                               && set the field handle to a positive value
      DO WHILE nField <= ObjHead.nNumFields              && loop through all the fields in the report

         IF dump
            ? lineno(), "aFields[" + ltrim( str( nField ) ) + ", 1] =", aFields[ nField, 1 ]
            ? lineno(), "aFields[" + ltrim( str( nField ) ) + ",14] =", aFields[ nField, 14 ]
         ENDIF
         *-------------------------------------         
         *-- Look for fields that are temporary
         *-------------------------------------         
         IF TYPE( "aFields[nField, 14]" ) # "N"    && Is the Band value not set
            IF dump
               ? lineno(), "Skipped, band not set!"
               ?
            ENDIF            
            nField = nField + 1
            LOOP
         ENDIF
         
         DO CASE

         * dbf/memvar type fields *
         CASE aFields[nField, 2] = 0 .OR. (aFields[nField, 2] = 1 .AND. empty(aFields[nField, 12])) .OR. aFields[nField, 2] = 4
            IF "QBE" $ upper(cDbfFile)
               nFldHndl = peNewDatabaseField(nCrwHndl, upper(ansi(parsePath((cDbfFile)) + "." + cDbf + "->" + aFields[nField, 1])))
            else
               nFldHndl = peNewDatabaseField(nCrwHndl, ansi(parsePath((cDbfFile)) + "." + parsePath((cDbfFile)) + "->" + aFields[nField, 1]))
            ENDIF
            IF nFldHndl = 0
               * error inserting a field...
            else
               lSet = peSetFieldLocation( nCrwHndl, ;
                                          nFldHndl, ;
                                          4000, ;
                                          aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing, ;
                                          TwipLoc( nField ) )
               lOk  = peSetFieldWidth( nCrwHndl, ;
                                       nFldHndl, ;
                                       TwipWidth( nField ) )
            ENDIF

         * calc type fields *
         CASE aFields[nField, 2] = 1
            *----------------------------------------------------------
            *-- Make up a name for the calc field if one does not exist
            *----------------------------------------------------------
            IF EMPTY( aFields[ nField, 1 ] )
               aFields[ nField, 1 ] = "CRW_CALC_" + LTRIM( STR( nField ) )
            ENDIF
            
            lFmlHndl = peNewFormula(nCrwHndl, ansi(aFields[nField, 1]), ansi(aFields[nField, 12]))
            nFldHndl = peNewFormulaField(nCrwHndl, ansi(aFields[nField, 1]))
            IF nFldHndl = 0
               * error inserting a formula field...
            else
               lSet = peSetFieldLocation( nCrwHndl, ;
                                          nFldHndl, ;
                                          4000, ;
                                          aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing, ;
                                          TwipLoc( nField ) )
               IF dump
                  ? lineno(), "peSetFieldLocation() =", lSet
               ENDIF
               
               lOk  = peSetFieldWidth( nCrwHndl, ;
                                       nFldHndl, ;
                                       TwipWidth( nField ) )
               IF dump
                  ? lineno(), "peSetFieldWidth() =", lOk
               ENDIF
               
            ENDIF

         * predef type fields *
         CASE aFields[nField, 2] = 3
            cbMsge(aFields[nField], msgAlert)
            DO CASE
            CASE aFields[nField, 8] = 2  && Recno
               nFldHndl = peNewSpecialVarField(nCrwHndl, 4)
            CASE aFields[nField, 8] = 3  && PageNo
               nFldHndl = peNewSpecialVarField(nCrwHndl, 5)
            CASE aFields[nField, 8] = 0  && Date
               nFldHndl = peNewSpecialVarField(nCrwHndl, 0)
            CASE aFields[nField, 8] = 1  && Time
               lFmlHndl = peNewFormula(nCrwHndl, ansi(aFields[nField, 1]), ansi( "TIME()" ) )
               nFldHndl = peNewFormulaField(nCrwHndl, ansi(aFields[nField, 1]))
            ENDCASE
            lSet = peSetFieldLocation(nCrwHndl, ;
                                      nFldHndl, ;
                                          4000, ;
                                      aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing, ;
                                      TwipLoc( nField ) )
            lOk  = peSetFieldWidth( nCrwHndl, ;
                                    nFldHndl, ;
                                    TwipWidth( nField ) )

         * text type fields *
         CASE aFields[nField, 2] = 9
            IF TYPE( "aFields[nField,4]" ) # "N"
               aFields[nField,4] = LEN(aFields[nField,1])
            ENDIF
            nTtlHndl = peNewTextField(nCrwHndl, ansi(aFields[nField, 1]))
            IF dump
               ? lineno(), "peNewTextField() =", nTtlHndl
            ENDIF
            
            IF nTtlHndl = 0
               * error inserting a field colmnu header...
            else
               * get the position of the matching field and move the text to match it...
               lSet = peSetFieldLocation( nCrwHndl, ;
                                          nTtlHndl, ;
                                          4000, ;
                                          aFields[nField, 15] * aBands[aFields[ nField, 14 ] ].Spacing, ;
                                          TwipLoc( nField ) )
            IF dump
               ? lineno(), "peSetFieldLocation() =", lSet
            ENDIF
               lOk  = peSetFieldWidth( nCrwHndl, ;
                                       nTtlHndl, ;
                                       TwipWidth( nField ) )
            IF dump
               ? lineno(), "peSetFieldWidth() =", lOk
            ENDIF
            ENDIF

            IF dump
               lineno(), "Added text:", aFields[nField, 1]
            ENDIF
         ENDCASE

         nField = nField + 1

      ENDDO

      fDispGen.txtGenrPcntDone.text    = "100%"  && update the status display form
      fDispGen.txtMsgeGenrDone.Visible = True
      fDispGen.txtMsgeWrit.text = msgWriting

      IF file(cRplFile)                          && save routine for rpt files
         delete file &cRplFile
      ENDIF

      lFontChng = peSetFont(nCrwHndl, 0, 1, ansi("Courier New"), 0, 0, 1, 12, -1, -1, -1, 0)

      lSaveCrw = peSavePrintJob(nCrwHndl, ansi(cRplFile))
      IF dump
         ? lineno(), "peSavePrintJob(nCrwHndl, ansi(cRplFile)) =", lSaveCrw
      ENDIF
      IF lSaveCrw = False
         * error saving the report...
      ENDIF

      lClsePjb = peClosePrintJob(nCrwHndl)       && close the print job
      IF dump
         ? lineno(), "peClosePrintJob(nCrwHndl) =", lClsePjb
      ENDIF
      IF lClsePjb = False                        && was there an error?
         * error closing CRW...
      ENDIF

      &&& - update the status display...
      fDispGen.txtGenrPcntDone.text = "100%"     && update the status display
      fDispGen.txtWritPcntDone.visible = True
      fDispGen.txtWritPcntDone.text = "100%"     && update the status display
      fDispGen.txtMsgeWritDone.Visible = True

      IF file(cViewFile)                         && if a CB view exists...
         set view to &cViewFile                  && restore the CB view environment
         delete file &cViewFile                  && delete it
      ENDIF

      &&& - save the stats on the outgoing report...
      select Project
      go ObjHead.nTempRec
      replace Project->destDate  with date()
      replace Project->destTime  with time()

      IF .NOT. empty(cCatName)                   && if this is a single file
         fDispGen.close()                        && kill the status display form
         hideStatusObjs()                        && hide status display objects
      else
         fDispGen.pCancel.text = mnuOk           && change the button to an OK button
         fDispGen.pCancel.upBitMap = "resource #20" && change the bitmap
      ENDIF

   else                                          && no fields were found...
      cbMsge(msgNoFieldsFound, msgSystemError)   && display error message
   ENDIF
   
   if dump
         set alternate off
         close alternate
   endif

RETURN (0)
*-- EOP: Lbl2Rpl WITH cTitle, cFrmFile, cDbfFile, cRplFile, cCatName

PROCEDURE dB3LblFill
PARAMETER pcDbfFile
*-----------------------------------------------------------------------------
*  DESCRIPTION
*     Perform the function of FillArrays, but for a dBASE III Plus LBL file.
*     Each row in the label represents a calc field for the resulting row.
*-----------------------------------------------------------------------------
IF dump
   ? lineno(), "Processing 3+ label"
ENDIF

   fDispGen.txtGenrPcntDone.text    = "20%"     && update the status display form
   fDispGen.txtReadPcntDone.Visible = True      && make the read pcnt done object visible
   fDispGen.txtReadPcntDone.text = "20%"        && make the read pcnt done object visible
   
   *------------------------------------------------------------------------
   *-- Open the DBF associated with the label in order to determine the type
   *-- of the current field or expression.
   *------------------------------------------------------------------------
   SET VIEW TO ( pcDbfFile )   

   AFieldSize = ObjHead.nNumFields
   PUBLIC ARRAY aFields[ AFieldSize, 17 ]
   
   *-------------------------------------
   *-- Fill in the basic band information
   *-------------------------------------
   PUBLIC ARRAY aBands[ 1 ]
   aBands[ 1 ] = new Band()
   aBands[ 1 ].NumLines = ObjHead.nHeight
   aBands[ 1 ].Spacing = 1
   aBands[ 1 ].SetSection()

   fDispGen.txtGenrPcntDone.text    = "30%"     && update the status display form
   fDispGen.txtReadPcntDone.text    = "30%"     && make the read pcnt done object visible
   nField = 0
   nCurrentRow = 0
   DO WHILE nField <= ObjHead.nNumFields .AND. .NOT. FEOF( nHandle )
      cLabelRow = FREAD( nHandle, 60 )          && Read in the next label expression
      
      if dump
         ? lineno(), "Row:", cLabelRow
      endif      
      
      *-----------------------
      *-- Skip over blank rows
      *-----------------------
      IF ISBLANK( cLabelRow ) .OR. LEFT( cLabelRow, 1 ) = CHR(2)
         nCurrentRow = nCurrentRow + 1
         LOOP
      ENDIF
      
      nField = nField + 1
      
      *---------------------------------------------------------------
      *-- The label row can consist of either an expression/field or a 
      *-- comma separated list of expressions/fields.  Comma separated
      *-- expressions are trimmed and added together.  We need to
      *-- build a real expression for the row.
      *---------------------------------------------------------------
      cRealExp = ""
      DO Old2New WITH cLabelRow, cRealExp
      
      if dump
         ? lineno(), "Real exp:", cRealExp
      endif
      
      aFields[nField, 01] = "LB_EXP_" + LTRIM( STR( nField ) )
      aFields[nField, 02] = 1             && Calc field
      aFields[nField, 03] = TYPE( cRealExp )
      aFields[nField, 04] = ObjHead.nWidth
      aFields[nField, 05] = ""
      aFields[nField, 06] = 0
      aFields[nField, 07] = "FF0"
      aFields[nField, 08] = 0
      aFields[nField, 09] = ""
      aFields[nField, 10] = ""
      aFields[nField, 11] = ""
      aFields[nField, 12] = cRealExp                           && Expression
      aFields[nField, 13] = 0                                  && Not used
      aFields[nField, 14] = 1                                  && Band ID
      aFields[nField, 15] = nCurrentRow                        && Row number
      aFields[nField, 16] = 0                                  && Column position
      aFields[nField, 17] = ObjHead.nWidth                     && Width
      
      nCurrentRow = nCurrentRow + 1
      
   ENDDO
   
   CLOSE DATABASE
   
   ObjHead.nNumFields = nField
   
   FCLOSE( nHandle )
   
   if dump
      ?
      ? "Dump of what is going to CRW"
      ? "============================"
      ?
      ? "* aFields ****************************"
      FOR n = 1 TO ObjHead.nNumFields
         ? "Fld:    ", aFields[n, 01]
         ? "Typ:    ", aFields[n, 02]
         ? "DatTyp: ", aFields[n, 03]
         ? "FldWid: ", aFields[n, 04]
         ? "Sum Fld:", aFields[n, 05]
         ? "Sum Op: ", aFields[n, 06]
         ? "HSR:    ", aFields[n, 07]
         ? ":       ", aFields[n, 08]
         ? ":       ", aFields[n, 09]
         ? ":       ", aFields[n, 10]
         ? ":       ", aFields[n, 11]
         ? "Formula:", aFields[n, 12]
         ? "Hdl:    ", aFields[n, 13]
         ? "Bnd:    ", aFields[n, 14]
         ? "Row:    ", aFields[n, 15]
         ? "Col:    ", aFields[n, 16]
         ? "Wid:    ", aFields[n, 17]
         ? "---------------------------------------"
      NEXT
      
   endif
      
   
   
   fDispGen.txtReadPcntDone.text = "100%"      && make the read pcnt done object visible
   fDispGen.txtGenrPcntDone.text    = "50%"   && update the status display form
   
RETURN
*-- EOP: dB3LblFill


PROCEDURE Old2New( cExpr, cOut )

   terminator = "+"
   sOut = ""
   operand = ""
   cWorkExp = cExpr
   
   DO WHILE .NOT. ISBLANK( terminator )
   
      cWorkExp = LTRIM( RTRIM( cWorkExp ) )
      IF ISBLANK( cWorkExp )
         EXIT
      ENDIF
      
      cWorkExp = GetOperand( cWorkExp, operand, terminator )
      Operand = TRIM( Operand )
      
      IF terminator = ","
         c1st = LEFT( Operand, 1 )
         IF c1st = '"' .OR. c1st = '[' .OR. c1st = "'"
            sOut = sOut + Operand 
         ELSE
            cType = TYPE( Operand )
            DO CASE
               CASE cType $ "NF"
                  sOut = sOut + "STR(" + Operand + ")"
               CASE cType = "D"
                  sOut = sOut + "DTOC(" + Operand + ")"
               CASE cType = "L"
                  sOut = sOut + "IIF(" + Operand + ",'T','F')"
               OTHERWISE
                  sOut = sOut + "TRIM(" + Operand + ")"
            ENDCASE
         ENDIF
         *-- Add the space between fields
         sOut = sOut + '+" "+'
      ELSE
         sOut = sOut + Operand + "+"
      ENDIF
   ENDDO
   
   IF RIGHT( sOut, 1 ) = "+"
      sOut = LEFT( sOut, LEN( sOut ) - 1 )
   ENDIF
   cOut = sOut
RETURN
*-- EOP: Old2New WITH cExpr, cOut


FUNCTION GetOperand( string, pcOperand, terminator )

   nParens = 0      && Keep track of nested parens
   sDelim  = ""     && string delimiter '"[
   terminator = ""
   sPtr = 1         && current position in the string
   nLen = LEN( string )
   pcOperand = ""
   
   DO WHILE ISBLANK( terminator ) .AND. sPtr <= nLen
   
      cChr = SUBSTR( string, sPtr, 1 )
      DO CASE
         CASE cChr = "'" .OR. cChr = '"'
            IF ISBLANK( sDelim )
               sDelim = cChr
            ELSE
               IF sDelim = cChr
                  sDelim = ""
               ENDIF
            ENDIF
            pcOperand = pcOperand + cChr
            sPtr = sPtr + 1
            
         CASE cChr = "["
            IF ISBLANK( sDelim )
               sDelim = cChr
            ENDIF
            pcOperand = pcOperand + cChr
            sPtr = sPtr + 1
            
         CASE cChr = "]"
            IF sDelim = "["
               sDelim = ""
            ENDIF
            pcOperand = pcOperand + cChr
            sPtr = sPtr + 1
            
         CASE cChr = "("
            IF ISBLANK( sDelim )
               nParens = nParens + 1
            ENDIF
            pcOperand = pcOperand + cChr
            sPtr = sPtr + 1
            
         CASE cChr = ")"
            IF ISBLANK( sDelim )
               nParens = nParens - 1
            ENDIF
            pcOperand = pcOperand + cChr
            sPtr = sPtr + 1
            
         CASE cChr = "+" .OR. cChr = ","
            IF ISBLANK( sDelim ) .AND. nParens = 0
               terminator = cChr
               sPtr = sPtr + 1
            ELSE
               pcOperand = pcOperand + cChr
               sPtr = sPtr + 1
            ENDIF
            
         OTHERWISE
            pcOperand = pcOperand + cChr
            sPtr = sPtr + 1
      ENDCASE
      
   ENDDO
   
   IF sPtr <= nLen
      cReturn = SUBSTR( string, sPtr )
   ELSE
      cReturn = ""
   ENDIF
   
RETURN cReturn
*-- EOF: GetOperand( string, pcOperand, terminator )

PROCEDURE closeAll
   fclose(nHandle)
RETURN

PROCEDURE killCrystalApi
   cbCrwApi = 0
RETURN

function word2num                                && Convert 2-byte word to Pro-type number.
   parameter bytes
return (asc(bytes) + (asc(substr(bytes, 2, 1)) * 256))

function readstring                              && Read a string formatted as 2-byte length + C-string.
   private strlength
   strlength = word2num(fread(nHandle, 2))
   if strlength = 0
      return ""
   endif
return xtrim(fread(nHandle, strlength))

function xtrim                                   && Trim spaces and nulls.
   parameter pstring
   private pos
   pos = at(chr(0), pstring)
   if pos > 0
      pstring = left(pstring, pos - 1)
   else
      pos = len(pstring)
      do while pos > 1 .and. asc(right(pstring, 1)) = 0
         pstring = left(pstring, len(pstring) - 1)
         pos = pos - 1
      enddo
   endif
   if pos = 1 .and. asc(pstring) = 0
      return ""
   endif
return ltrim(trim(pstring))

FUNCTION reOpenProject
   select Project 
   nTemp = recno()
   use
   use cbproj alias Project in select() exclusive
   select Project
   go nTemp
RETURN (Void)

FUNCTION formatStr(string, repStr)
RETURN STUFF(string, at("%s",string), 2, repStr)

FUNCTION cbPath
RETURN(substr(program(0), 1, rat("\", program(0))))

function MakeInt(int)
return chr(bitand(int,255))+chr(bitr(int,8))

FUNCTION HexStr2Bin( hexString )
*---------------------------------------------------------------------
*  DESCRIPTION
*     Convert a hex string of characters to a numeric value.  Used to
*     convert field pointer numbers in wordwrap bands that are stored
*     using an eight byte character string.
*
*  EXAMPLE
*     x = HexStr2Bin( "0A000000" )   && x = 10
*---------------------------------------------------------------------
    constHex = "0123456789ABCDEF"
    nLenHex = LEN( hexString )
    nResult = 0

    declare multi[8]
    multi[1] = 16
    multi[2] = 1
    multi[3] = 4096
    multi[4] = 256 
    multi[5] = 0    && Not going over this number of fields
    multi[6] = 0
    multi[7] = 0
    multi[8] = 0

    FOR i = 1 TO nLenHex
        nibble = SUBSTR( hexString, i, 1 )
        decval = AT( nibble, constHex ) - 1
        nResult = nResult + ( decval * multi[ i ] )
    ENDFOR

RETURN nResult

FUNCTION TokValue( cResult, cSource, nTokStart )
*------------------------------------------------------------------------
*  DESCRIPTION
*     Store the bytes from the nTokStart position to the tok_end position
*     into cResult.  Return the next position in cSource after tok_end.
*------------------------------------------------------------------------
   cResult = ""
   nNextPos = 0
   FOR i = 1 TO MAX_TOKEN_SIZE
      nNextPos = nTokStart + i
      cByte = SUBSTR( cSource, nNextPos, 1 )
      IF cByte # TOK_END
          cResult = cResult + cByte
      ELSE
          nNextPos = nNextPos + 1
          EXIT
      ENDIF
   ENDFOR

RETURN nNextPos

FUNCTION  A2B3(cPtr)
*--------------------------------------------------------------------
*  DESCRIPTION
*     Convert 3 ASCII characters to binary.  A simple call to VAL()
*     won't work because there may be a non-numeric ASCII character
*     for negative values.
*--------------------------------------------------------------------
   LOCAL c, p, sum
   c = ""	&& Current character
   p = 1        && Pointer to character in  cPtr
   sum = 0	&& Resulting value
   
   FOR i = 3 TO 1 STEP -1
      c = SUBSTR( cPtr, p, 1 )
      p = p + 1
      IF c # ' '
         sum = ( 10 * sum ) + ( asc( c ) - asc( '0' ) )
      ENDIF
   ENDFOR
RETURN (sum)

#define RPT_FIELD_TYPE  aFields[ pToAdd, 2 ]
#define RPT_FIELD_NAME  aFields[ pToAdd, 1 ]
#define RPT_FIELD_PICT  aFields[ pToAdd, 10 ]
#define RPT_FIELD_FUNC  aFields[ pToAdd, 11 ]
#define RPT_FIELD_FORM  aFields[ pToAdd, 12 ]
#define DBF_FIELD       0
#define CALC_FIELD      1
#define SUMM_FIELD      2
#define PREDEFINE_FIELD 3
#define MEMORY_FIELD    4

FUNCTION AddToForm
PARAMETERS pcCurrExp, pToAdd
*---------------------------------------------------------------------
*  DESCRIPTION
*     This function adds to the <pcCurrExp> either a text string or
*     a field number expression and returns the resulting expression.
*     This result is used later on to create a Crystal Reports 
*     formula for word wrap bands.  Fields are transformed to strings
*     to create the expression.
*  PARAMETERS
*     pcCurrExp   = Current expression to add to
*     pToAdd      = String or field number to add to. The field number
*                   refers to the field in aFields.
*---------------------------------------------------------------------

   cType = TYPE( "pToAdd" )
   IF dump
      ? lineno(), "In AddToForm(), pToAdd =", pToAdd, "TYPE:", cType
   ENDIF   
   
   
   IF ISBLANK( pcCurrExp ) .AND. LEN( pcCurrExp ) = 0
      cOperator = ""
   ELSE
      cOperator = " + "
   ENDIF
   
   cReturn = ""
   cExp = ""
   
   DO CASE
      CASE cType = "C"
         IF LEN( pToAdd ) > 0
            cReturn = pcCurrExp + cOperator + Delimit( pToAdd )
            IF dump
               ? lineno(), "Add text:", cReturn
            ENDIF
         ELSE
            cReturn = pcCurrExp
            IF dump
               ? lineno(), "Add nothing to text:", cReturn
            ENDIF
         ENDIF
                  
      CASE cType = "N"
         *-- Get the field reference data from aFields[]
         IF dump
            ? lineno(), "Name:", RPT_FIELD_NAME, "Type:", RPT_FIELD_TYPE
         ENDIF
         
         DO CASE
            CASE RPT_FIELD_TYPE = DBF_FIELD .OR. RPT_FIELD_TYPE = MEMORY_FIELD
               cExp = "TRANSFORM( " + RPT_FIELD_NAME + ", "
               IF .NOT. ISBLANK( RPT_FIELD_FUNC )
                  cExp = cExp + '"@' + RPT_FIELD_FUNC + " "
               ELSE
                  cExp = cExp + '"'
               ENDIF
               cExp = cExp + RPT_FIELD_PICT + '" )'

            CASE RPT_FIELD_TYPE = CALC_FIELD
               cExp = "TRANSFORM( " + RPT_FIELD_FORM + ", "
               IF .NOT. ISBLANK( RPT_FIELD_FUNC )
                  cExp = cExp + '"@' + RPT_FIELD_FUNC + " "
               ELSE
                  cExp = cExp + '"'
               ENDIF
               cExp = cExp + RPT_FIELD_PICT + '" )'

            CASE RPT_FIELD_TYPE = PREDEFINE_FIELD
               DO CASE
                  CASE RPT_FIELD_NAME = "DATE"
                     cFormula = "DATE()"
                  CASE RPT_FIELD_NAME = "TIME"
                     cFormula = "TIME()"
                  CASE RPT_FIELD_NAME = "RECNO"
                     cFormula = "RECNO()"
                  OTHERWISE
                     cFormula = "1"
               ENDCASE
               
               cExp = "TRANSFORM( " + cFormula + ", "
               IF .NOT. ISBLANK( RPT_FIELD_FUNC )
                  cExp = cExp + '"@' + RPT_FIELD_FUNC + " "
               ELSE
                  cExp = cExp + '"'
               ENDIF
               cExp = cExp + RPT_FIELD_PICT + '" )'
               
            OTHERWISE                   && Ignore summary fields for now
               RETURN pcCurrExp
               
         ENDCASE
         cReturn = pcCurrExp + cOperator + cExp
         IF dump
            ? lineno(), "Add field:", cReturn
         ENDIF
         
      OTHERWISE
         cReturn = pcCurrExp          
         IF dump
            ? lineno(), "Otherwise", cReturn
         ENDIF
               
   ENDCASE
RETURN cReturn


#define ALLTRIM(kStr)  LTRIM(RTRIM(kStr))

FUNCTION Delimit
PARAMETERS pcString
*----------------------------------------------------------------------------
* DESCRIPTION
*  This function returns a delimited string based on the delimiters contained
*  within the string.  Single character values are represented using the
*  CHR() function.
*
* PARAMETERS
*   pcString   = String to add the delimiters to.
*
*----------------------------------------------------------------------------
    PRIVATE lcResult, cLeft, cRight

    IF ASC( m->pcString ) < 32
        IF LEN( m->pcString ) = 1
            lcResult = "CHR(" + ALLTRIM(STR(ASC(m->pcString))) + ")"
        ELSE
            IF LEN( m->pcString ) = 0
                lcResult = '""'
            ELSE
                cLeft= '"'
                cRight = '"'
                IF AT( '"', m->pcString ) > 0
                    IF AT( "'", m->pcString ) > 0
                        cLeft = "["
                        cRight = "]"
                    ELSE
                        cLeft = "'"
                        cRight = "'"
                    ENDIF
                ENDIF
                lcResult = m->cLeft + m->pcString + m->cRight
            ENDIF
        ENDIF
    ELSE
        cLeft= '"'
        cRight = '"'
        IF AT( '"', m->pcString ) > 0
            IF AT( "'", m->pcString ) > 0
                cLeft = "["
                cRight = "]"
            ELSE
                cLeft = "'"
                cRight = "'"
            ENDIF
        ENDIF
        lcResult = m->cLeft + m->pcString + m->cRight
    ENDIF

RETURN( m->lcResult )
*-- EOF: Delimit( pcString )

*-------------------------------------------------------------------------
*-- Yes, a TWIP is really 1/1440 of an inch, but the original calculations
*-- were made with this value.
*-------------------------------------------------------------------------
#define TWIPVAL 1140

FUNCTION TwipLoc( nField )
*-----------------------------------------------------------------------------
*  DESCRIPTION
*     Use that band font information to determine the location of the field.
*-----------------------------------------------------------------------------
   nBand = AFields[nField,14]
   nPitch = ABands[nBand].TextPitch
   DO CASE
      CASE nPitch = 0 .OR. nPitch = 3     && Pica or default
         CPI      = 60.5/5.5
         FACTOR   = 1.44848

      CASE nPitch = 1                     && Elite
         CPI      = 73.5/6
         FACTOR   = 1.129169
         
      CASE nPitch = 2                     && Compressed
         CPI      = 94/6
         FACTOR   = 1.239283

   ENDCASE
   
   
RETURN ( aFields[nField, 16] / CPI * FACTOR * TWIPVAL )

FUNCTION TwipWidth( nField )
*-----------------------------------------------------------------------------
*  DESCRIPTION
*     Use that band font information to determine the width of the field.
*-----------------------------------------------------------------------------
   nBand = AFields[nField,14]
   nPitch = ABands[nBand].TextPitch
   DO CASE
      CASE nPitch = 0 .OR. nPitch = 3     && Pica or default
         CPI      = 60.5/5.5
         FACTOR   = 1.44848

      CASE nPitch = 1                     && Elite
         CPI      = 73.5/6
         FACTOR   = 1.129169
         
      CASE nPitch = 2                     && Compressed
         CPI      = 94/6
         FACTOR   = 1.239283

   ENDCASE
   
   QTRCHAR = .25 / CPI * TWIPVAL
   
RETURN ( ( aFields[nField,4] / CPI * FACTOR * TWIPVAL ) + QTRCHAR )

FUNCTION MatchLabel
*-----------------------------------------------------------------------------
*  DESCRIPTION
*     Use the ObjHead object values for the label size and match it up
*     with the available CRW values in LABLES.TXT
*-----------------------------------------------------------------------------

   nRows = 80
   *----------------------------------------------
   *-- Build the array if it doesn't already exist
   *----------------------------------------------
   IF TYPE("aLabel[1,1]") # "C"
      RELEASE aLabel
      
      DO BuildLabel        && See #include buildlab.prg
      
   ENDIF
   
   nRows = ALEN( aLabel, 1 )
   
   *------------------------------------------------------
   *-- Compare the values in ObjHead for the closest match
   *------------------------------------------------------
   nBestVal = 0
   nBestRow = 0
   FOR i = 1 TO nRows
      k = 0
      k = IIF( ObjHead.nHeight     = aLabel[ i, 3], k + 1, k )
      k = IIF( ObjHead.nWidth      = aLabel[ i, 2], k + 1, k ) 
      k = IIF( ObjHead.nLeftMargin = aLabel[ i, 4], k + 1, k ) 
      k = IIF( ObjHead.nRowSpace   = aLabel[ i, 5], k + 1, k ) 
      k = IIF( ObjHead.nColSpace   = aLabel[ i, 6], k + 1, k ) 
      k = IIF( ObjHead.nColumns    = aLabel[ i, 7], k + 1, k )
      k = IIF( ObjHead.LabRows     = aLabel[ i, 8], k + 1, k ) 
      IF k > nBestVal
         nBestVal = k
         nBestRow = i
      ENDIF
   NEXT
   
   IF nBestRow > 0
      LabelName = aLabel[ nBestRow, 9 ]
   ELSE
      LabelName = aLabel[ 1, 9 ]          && Use the first one in the list
   ENDIF
   
   
RETURN ( LabelName )
*-- EOF: MatchLabel()


#include "buildlab.prg"

